/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAudioContextState.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(AudioContextState enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("suspended"),
        MAKE_STATIC_STRING_IMPL("running"),
        MAKE_STATIC_STRING_IMPL("interrupted"),
        MAKE_STATIC_STRING_IMPL("closed"),
    };
    static_assert(static_cast<size_t>(AudioContextState::Suspended) == 0, "AudioContextState::Suspended is not 0 as expected");
    static_assert(static_cast<size_t>(AudioContextState::Running) == 1, "AudioContextState::Running is not 1 as expected");
    static_assert(static_cast<size_t>(AudioContextState::Interrupted) == 2, "AudioContextState::Interrupted is not 2 as expected");
    static_assert(static_cast<size_t>(AudioContextState::Closed) == 3, "AudioContextState::Closed is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, AudioContextState enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<AudioContextState> parseEnumeration<AudioContextState>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "suspended")
        return AudioContextState::Suspended;
    if (stringValue == "running")
        return AudioContextState::Running;
    if (stringValue == "interrupted")
        return AudioContextState::Interrupted;
    if (stringValue == "closed")
        return AudioContextState::Closed;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<AudioContextState>()
{
    return "\"suspended\", \"running\", \"interrupted\", \"closed\"";
}

} // namespace WebCore
