/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSChannelInterpretation.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(ChannelInterpretation enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("speakers"),
        MAKE_STATIC_STRING_IMPL("discrete"),
    };
    static_assert(static_cast<size_t>(ChannelInterpretation::Speakers) == 0, "ChannelInterpretation::Speakers is not 0 as expected");
    static_assert(static_cast<size_t>(ChannelInterpretation::Discrete) == 1, "ChannelInterpretation::Discrete is not 1 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, ChannelInterpretation enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<ChannelInterpretation> parseEnumeration<ChannelInterpretation>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "speakers")
        return ChannelInterpretation::Speakers;
    if (stringValue == "discrete")
        return ChannelInterpretation::Discrete;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<ChannelInterpretation>()
{
    return "\"speakers\", \"discrete\"";
}

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
