/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCompositeOperation.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(CompositeOperation enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("replace"),
        MAKE_STATIC_STRING_IMPL("add"),
        MAKE_STATIC_STRING_IMPL("accumulate"),
    };
    static_assert(static_cast<size_t>(CompositeOperation::Replace) == 0, "CompositeOperation::Replace is not 0 as expected");
    static_assert(static_cast<size_t>(CompositeOperation::Add) == 1, "CompositeOperation::Add is not 1 as expected");
    static_assert(static_cast<size_t>(CompositeOperation::Accumulate) == 2, "CompositeOperation::Accumulate is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, CompositeOperation enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<CompositeOperation> parseEnumeration<CompositeOperation>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "replace")
        return CompositeOperation::Replace;
    if (stringValue == "add")
        return CompositeOperation::Add;
    if (stringValue == "accumulate")
        return CompositeOperation::Accumulate;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<CompositeOperation>()
{
    return "\"replace\", \"add\", \"accumulate\"";
}

} // namespace WebCore
