/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSContactProperty.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(ContactProperty enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("email"),
        MAKE_STATIC_STRING_IMPL("name"),
        MAKE_STATIC_STRING_IMPL("tel"),
    };
    static_assert(static_cast<size_t>(ContactProperty::Email) == 0, "ContactProperty::Email is not 0 as expected");
    static_assert(static_cast<size_t>(ContactProperty::Name) == 1, "ContactProperty::Name is not 1 as expected");
    static_assert(static_cast<size_t>(ContactProperty::Tel) == 2, "ContactProperty::Tel is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, ContactProperty enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<ContactProperty> parseEnumeration<ContactProperty>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "email")
        return ContactProperty::Email;
    if (stringValue == "name")
        return ContactProperty::Name;
    if (stringValue == "tel")
        return ContactProperty::Tel;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<ContactProperty>()
{
    return "\"email\", \"name\", \"tel\"";
}

} // namespace WebCore
