/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUFeatureName.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(GPUFeatureName enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("depth-clip-control"),
        MAKE_STATIC_STRING_IMPL("depth24unorm-stencil8"),
        MAKE_STATIC_STRING_IMPL("depth32float-stencil8"),
        MAKE_STATIC_STRING_IMPL("texture-compression-bc"),
        MAKE_STATIC_STRING_IMPL("texture-compression-etc2"),
        MAKE_STATIC_STRING_IMPL("texture-compression-astc"),
        MAKE_STATIC_STRING_IMPL("timestamp-query"),
        MAKE_STATIC_STRING_IMPL("indirect-first-instance"),
    };
    static_assert(static_cast<size_t>(GPUFeatureName::DepthClipControl) == 0, "GPUFeatureName::DepthClipControl is not 0 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::Depth24unormStencil8) == 1, "GPUFeatureName::Depth24unormStencil8 is not 1 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::Depth32floatStencil8) == 2, "GPUFeatureName::Depth32floatStencil8 is not 2 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::TextureCompressionBc) == 3, "GPUFeatureName::TextureCompressionBc is not 3 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::TextureCompressionEtc2) == 4, "GPUFeatureName::TextureCompressionEtc2 is not 4 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::TextureCompressionAstc) == 5, "GPUFeatureName::TextureCompressionAstc is not 5 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::TimestampQuery) == 6, "GPUFeatureName::TimestampQuery is not 6 as expected");
    static_assert(static_cast<size_t>(GPUFeatureName::IndirectFirstInstance) == 7, "GPUFeatureName::IndirectFirstInstance is not 7 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, GPUFeatureName enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<GPUFeatureName> parseEnumeration<GPUFeatureName>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "depth-clip-control")
        return GPUFeatureName::DepthClipControl;
    if (stringValue == "depth24unorm-stencil8")
        return GPUFeatureName::Depth24unormStencil8;
    if (stringValue == "depth32float-stencil8")
        return GPUFeatureName::Depth32floatStencil8;
    if (stringValue == "texture-compression-bc")
        return GPUFeatureName::TextureCompressionBc;
    if (stringValue == "texture-compression-etc2")
        return GPUFeatureName::TextureCompressionEtc2;
    if (stringValue == "texture-compression-astc")
        return GPUFeatureName::TextureCompressionAstc;
    if (stringValue == "timestamp-query")
        return GPUFeatureName::TimestampQuery;
    if (stringValue == "indirect-first-instance")
        return GPUFeatureName::IndirectFirstInstance;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<GPUFeatureName>()
{
    return "\"depth-clip-control\", \"depth24unorm-stencil8\", \"depth32float-stencil8\", \"texture-compression-bc\", \"texture-compression-etc2\", \"texture-compression-astc\", \"timestamp-query\", \"indirect-first-instance\"";
}

} // namespace WebCore
