/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUImageDataLayout.h"

#include "JSDOMConvertNumbers.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> GPUImageDataLayout convertDictionary<GPUImageDataLayout>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    GPUImageDataLayout result;
    JSValue bytesPerRowValue;
    if (isNullOrUndefined)
        bytesPerRowValue = jsUndefined();
    else {
        bytesPerRowValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bytesPerRow"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!bytesPerRowValue.isUndefined()) {
        result.bytesPerRow = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(lexicalGlobalObject, bytesPerRowValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue offsetValue;
    if (isNullOrUndefined)
        offsetValue = jsUndefined();
    else {
        offsetValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "offset"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!offsetValue.isUndefined()) {
        result.offset = convert<IDLEnforceRangeAdaptor<IDLUnsignedLongLong>>(lexicalGlobalObject, offsetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.offset = 0;
    JSValue rowsPerImageValue;
    if (isNullOrUndefined)
        rowsPerImageValue = jsUndefined();
    else {
        rowsPerImageValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "rowsPerImage"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!rowsPerImageValue.isUndefined()) {
        result.rowsPerImage = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(lexicalGlobalObject, rowsPerImageValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
