/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUSupportedLimits.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimitsConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension1D);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension2D);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension3D);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureArrayLayers);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxBindGroups);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxDynamicUniformBuffersPerPipelineLayout);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxDynamicStorageBuffersPerPipelineLayout);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxSampledTexturesPerShaderStage);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxSamplersPerShaderStage);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageBuffersPerShaderStage);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageTexturesPerShaderStage);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxUniformBuffersPerShaderStage);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxUniformBufferBindingSize);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageBufferBindingSize);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_minUniformBufferOffsetAlignment);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_minStorageBufferOffsetAlignment);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexBuffers);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexAttributes);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexBufferArrayStride);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxInterStageShaderComponents);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupStorageSize);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeInvocationsPerWorkgroup);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeX);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeY);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeZ);
static JSC_DECLARE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupsPerDimension);

class JSGPUSupportedLimitsPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSGPUSupportedLimitsPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSGPUSupportedLimitsPrototype* ptr = new (NotNull, JSC::allocateCell<JSGPUSupportedLimitsPrototype>(vm)) JSGPUSupportedLimitsPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUSupportedLimitsPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSGPUSupportedLimitsPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUSupportedLimitsPrototype, JSGPUSupportedLimitsPrototype::Base);

using JSGPUSupportedLimitsDOMConstructor = JSDOMConstructorNotConstructable<JSGPUSupportedLimits>;

template<> const ClassInfo JSGPUSupportedLimitsDOMConstructor::s_info = { "GPUSupportedLimits", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUSupportedLimitsDOMConstructor) };

template<> JSValue JSGPUSupportedLimitsDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSGPUSupportedLimitsDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "GPUSupportedLimits"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSGPUSupportedLimits::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSGPUSupportedLimitsPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimitsConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxTextureDimension1D", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxTextureDimension1D), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxTextureDimension2D", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxTextureDimension2D), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxTextureDimension3D", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxTextureDimension3D), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxTextureArrayLayers", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxTextureArrayLayers), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxBindGroups", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxBindGroups), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxDynamicUniformBuffersPerPipelineLayout", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxDynamicUniformBuffersPerPipelineLayout), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxDynamicStorageBuffersPerPipelineLayout", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxDynamicStorageBuffersPerPipelineLayout), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxSampledTexturesPerShaderStage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxSampledTexturesPerShaderStage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxSamplersPerShaderStage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxSamplersPerShaderStage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxStorageBuffersPerShaderStage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxStorageBuffersPerShaderStage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxStorageTexturesPerShaderStage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxStorageTexturesPerShaderStage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxUniformBuffersPerShaderStage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxUniformBuffersPerShaderStage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxUniformBufferBindingSize", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxUniformBufferBindingSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxStorageBufferBindingSize", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxStorageBufferBindingSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "minUniformBufferOffsetAlignment", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_minUniformBufferOffsetAlignment), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "minStorageBufferOffsetAlignment", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_minStorageBufferOffsetAlignment), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxVertexBuffers", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxVertexBuffers), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxVertexAttributes", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxVertexAttributes), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxVertexBufferArrayStride", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxVertexBufferArrayStride), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxInterStageShaderComponents", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxInterStageShaderComponents), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeWorkgroupStorageSize", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeWorkgroupStorageSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeInvocationsPerWorkgroup", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeInvocationsPerWorkgroup), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeWorkgroupSizeX", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeWorkgroupSizeX), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeWorkgroupSizeY", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeWorkgroupSizeY), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeWorkgroupSizeZ", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeWorkgroupSizeZ), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxComputeWorkgroupsPerDimension", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUSupportedLimits_maxComputeWorkgroupsPerDimension), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSGPUSupportedLimitsPrototype::s_info = { "GPUSupportedLimits", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUSupportedLimitsPrototype) };

void JSGPUSupportedLimitsPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSGPUSupportedLimits::info(), JSGPUSupportedLimitsPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSGPUSupportedLimits::s_info = { "GPUSupportedLimits", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUSupportedLimits) };

JSGPUSupportedLimits::JSGPUSupportedLimits(Structure* structure, JSDOMGlobalObject& globalObject, Ref<GPUSupportedLimits>&& impl)
    : JSDOMWrapper<GPUSupportedLimits>(structure, globalObject, WTFMove(impl))
{
}

void JSGPUSupportedLimits::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, GPUSupportedLimits>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSGPUSupportedLimits::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSGPUSupportedLimitsPrototype::create(vm, &globalObject, JSGPUSupportedLimitsPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSGPUSupportedLimits::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSGPUSupportedLimits>(vm, globalObject);
}

JSValue JSGPUSupportedLimits::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUSupportedLimitsDOMConstructor, DOMConstructorID::GPUSupportedLimits>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUSupportedLimits::destroy(JSC::JSCell* cell)
{
    JSGPUSupportedLimits* thisObject = static_cast<JSGPUSupportedLimits*>(cell);
    thisObject->JSGPUSupportedLimits::~JSGPUSupportedLimits();
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimitsConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSGPUSupportedLimitsPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSGPUSupportedLimits::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsGPUSupportedLimits_maxTextureDimension1DGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxTextureDimension1D())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension1D, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxTextureDimension1DGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxTextureDimension2DGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxTextureDimension2D())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension2D, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxTextureDimension2DGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxTextureDimension3DGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxTextureDimension3D())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureDimension3D, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxTextureDimension3DGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxTextureArrayLayersGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxTextureArrayLayers())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxTextureArrayLayers, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxTextureArrayLayersGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxBindGroupsGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxBindGroups())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxBindGroups, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxBindGroupsGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxDynamicUniformBuffersPerPipelineLayoutGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxDynamicUniformBuffersPerPipelineLayout())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxDynamicUniformBuffersPerPipelineLayout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxDynamicUniformBuffersPerPipelineLayoutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxDynamicStorageBuffersPerPipelineLayoutGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxDynamicStorageBuffersPerPipelineLayout())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxDynamicStorageBuffersPerPipelineLayout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxDynamicStorageBuffersPerPipelineLayoutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxSampledTexturesPerShaderStageGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxSampledTexturesPerShaderStage())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxSampledTexturesPerShaderStage, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxSampledTexturesPerShaderStageGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxSamplersPerShaderStageGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxSamplersPerShaderStage())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxSamplersPerShaderStage, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxSamplersPerShaderStageGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxStorageBuffersPerShaderStageGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxStorageBuffersPerShaderStage())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageBuffersPerShaderStage, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxStorageBuffersPerShaderStageGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxStorageTexturesPerShaderStageGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxStorageTexturesPerShaderStage())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageTexturesPerShaderStage, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxStorageTexturesPerShaderStageGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxUniformBuffersPerShaderStageGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxUniformBuffersPerShaderStage())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxUniformBuffersPerShaderStage, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxUniformBuffersPerShaderStageGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxUniformBufferBindingSizeGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLongLong>(lexicalGlobalObject, throwScope, impl.maxUniformBufferBindingSize())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxUniformBufferBindingSize, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxUniformBufferBindingSizeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxStorageBufferBindingSizeGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLongLong>(lexicalGlobalObject, throwScope, impl.maxStorageBufferBindingSize())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxStorageBufferBindingSize, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxStorageBufferBindingSizeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_minUniformBufferOffsetAlignmentGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.minUniformBufferOffsetAlignment())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_minUniformBufferOffsetAlignment, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_minUniformBufferOffsetAlignmentGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_minStorageBufferOffsetAlignmentGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.minStorageBufferOffsetAlignment())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_minStorageBufferOffsetAlignment, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_minStorageBufferOffsetAlignmentGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxVertexBuffersGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxVertexBuffers())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexBuffers, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxVertexBuffersGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxVertexAttributesGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxVertexAttributes())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexAttributes, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxVertexAttributesGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxVertexBufferArrayStrideGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxVertexBufferArrayStride())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxVertexBufferArrayStride, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxVertexBufferArrayStrideGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxInterStageShaderComponentsGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxInterStageShaderComponents())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxInterStageShaderComponents, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxInterStageShaderComponentsGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeWorkgroupStorageSizeGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeWorkgroupStorageSize())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupStorageSize, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeWorkgroupStorageSizeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeInvocationsPerWorkgroupGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeInvocationsPerWorkgroup())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeInvocationsPerWorkgroup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeInvocationsPerWorkgroupGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeWorkgroupSizeXGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeWorkgroupSizeX())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeX, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeWorkgroupSizeXGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeWorkgroupSizeYGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeWorkgroupSizeY())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeY, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeWorkgroupSizeYGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeWorkgroupSizeZGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeWorkgroupSizeZ())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupSizeZ, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeWorkgroupSizeZGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsGPUSupportedLimits_maxComputeWorkgroupsPerDimensionGetter(JSGlobalObject& lexicalGlobalObject, JSGPUSupportedLimits& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxComputeWorkgroupsPerDimension())));
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUSupportedLimits_maxComputeWorkgroupsPerDimension, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSGPUSupportedLimits>::get<jsGPUSupportedLimits_maxComputeWorkgroupsPerDimensionGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

JSC::GCClient::IsoSubspace* JSGPUSupportedLimits::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSGPUSupportedLimits, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForGPUSupportedLimits.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForGPUSupportedLimits = WTFMove(space); },
        [] (auto& spaces) { return spaces.m_subspaceForGPUSupportedLimits.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForGPUSupportedLimits = WTFMove(space); }
    );
}

void JSGPUSupportedLimits::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSGPUSupportedLimits*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSGPUSupportedLimitsOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSGPUSupportedLimitsOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsGPUSupportedLimits = static_cast<JSGPUSupportedLimits*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsGPUSupportedLimits->wrapped(), jsGPUSupportedLimits);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7GPUSupportedLimits@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18GPUSupportedLimitsE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<GPUSupportedLimits>&& impl)
{

    if constexpr (std::is_polymorphic_v<GPUSupportedLimits>) {
#if ENABLE(BINDING_INTEGRITY)
        const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7GPUSupportedLimits@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore18GPUSupportedLimitsE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // GPUSupportedLimits has subclasses. If GPUSupportedLimits has subclasses that get passed
        // to toJS() we currently require GPUSupportedLimits you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    }
    return createWrapper<GPUSupportedLimits>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, GPUSupportedLimits& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

GPUSupportedLimits* JSGPUSupportedLimits::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSGPUSupportedLimits*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
