/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSIDBTransactionDurability.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(IDBTransactionDurability enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("strict"),
        MAKE_STATIC_STRING_IMPL("relaxed"),
        MAKE_STATIC_STRING_IMPL("default"),
    };
    static_assert(static_cast<size_t>(IDBTransactionDurability::Strict) == 0, "IDBTransactionDurability::Strict is not 0 as expected");
    static_assert(static_cast<size_t>(IDBTransactionDurability::Relaxed) == 1, "IDBTransactionDurability::Relaxed is not 1 as expected");
    static_assert(static_cast<size_t>(IDBTransactionDurability::Default) == 2, "IDBTransactionDurability::Default is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, IDBTransactionDurability enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<IDBTransactionDurability> parseEnumeration<IDBTransactionDurability>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "strict")
        return IDBTransactionDurability::Strict;
    if (stringValue == "relaxed")
        return IDBTransactionDurability::Relaxed;
    if (stringValue == "default")
        return IDBTransactionDurability::Default;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<IDBTransactionDurability>()
{
    return "\"strict\", \"relaxed\", \"default\"";
}

} // namespace WebCore
