/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMediaCapabilitiesInfo.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> MediaCapabilitiesInfo convertDictionary<MediaCapabilitiesInfo>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    MediaCapabilitiesInfo result;
    JSValue powerEfficientValue;
    if (isNullOrUndefined)
        powerEfficientValue = jsUndefined();
    else {
        powerEfficientValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "powerEfficient"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!powerEfficientValue.isUndefined()) {
        result.powerEfficient = convert<IDLBoolean>(lexicalGlobalObject, powerEfficientValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "powerEfficient", "MediaCapabilitiesInfo", "boolean");
        return { };
    }
    JSValue smoothValue;
    if (isNullOrUndefined)
        smoothValue = jsUndefined();
    else {
        smoothValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "smooth"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!smoothValue.isUndefined()) {
        result.smooth = convert<IDLBoolean>(lexicalGlobalObject, smoothValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "smooth", "MediaCapabilitiesInfo", "boolean");
        return { };
    }
    JSValue supportedValue;
    if (isNullOrUndefined)
        supportedValue = jsUndefined();
    else {
        supportedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "supported"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!supportedValue.isUndefined()) {
        result.supported = convert<IDLBoolean>(lexicalGlobalObject, supportedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "supported", "MediaCapabilitiesInfo", "boolean");
        return { };
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const MediaCapabilitiesInfo& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto powerEfficientValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.powerEfficient);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "powerEfficient"), powerEfficientValue);
    auto smoothValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.smooth);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "smooth"), smoothValue);
    auto supportedValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.supported);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "supported"), supportedValue);
    return result;
}

} // namespace WebCore
