/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSSQLStatementCallback.h"

#include "JSDOMConvertBase.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSSQLResultSet.h"
#include "JSSQLTransaction.h"
#include "ScriptExecutionContext.h"


namespace WebCore {
using namespace JSC;

JSSQLStatementCallback::JSSQLStatementCallback(VM& vm, JSObject* callback)
    : SQLStatementCallback(jsCast<JSDOMGlobalObject*>(callback->globalObject(vm))->scriptExecutionContext())
    , m_data(new JSCallbackDataStrong(vm, callback, this))
{
}

JSSQLStatementCallback::~JSSQLStatementCallback()
{
    ScriptExecutionContext* context = scriptExecutionContext();
    // When the context is destroyed, all tasks with a reference to a callback
    // should be deleted. So if the context is 0, we are on the context thread.
    if (!context || context->isContextThread())
        delete m_data;
    else
        context->postTask(DeleteCallbackDataTask(m_data));
#ifndef NDEBUG
    m_data = nullptr;
#endif
}

CallbackResult<typename IDLUndefined::ImplementationType> JSSQLStatementCallback::handleEvent(typename IDLInterface<SQLTransaction>::ParameterType transaction, typename IDLInterface<SQLResultSet>::ParameterType resultSet)
{
    if (!canInvokeCallback())
        return CallbackResultType::UnableToExecute;

    Ref<JSSQLStatementCallback> protectedThis(*this);

    auto& globalObject = *jsCast<JSDOMGlobalObject*>(scriptExecutionContext()->globalObject());
    auto& vm = globalObject.vm();

    JSLockHolder lock(vm);
    auto& lexicalGlobalObject = globalObject;
    JSValue thisValue = jsUndefined();
    MarkedArgumentBuffer args;
    args.append(toJS<IDLInterface<SQLTransaction>>(lexicalGlobalObject, globalObject, transaction));
    args.append(toJS<IDLInterface<SQLResultSet>>(lexicalGlobalObject, globalObject, resultSet));
    ASSERT(!args.hasOverflowed());

    NakedPtr<JSC::Exception> returnedException;
    m_data->invokeCallback(vm, thisValue, args, JSCallbackData::CallbackType::Function, Identifier(), returnedException);
    if (returnedException) {
        reportException(&lexicalGlobalObject, returnedException);
        return CallbackResultType::ExceptionThrown;
     }

    return { };
}

JSC::JSValue toJS(SQLStatementCallback& impl)
{
    if (!static_cast<JSSQLStatementCallback&>(impl).callbackData())
        return jsNull();

    return static_cast<JSSQLStatementCallback&>(impl).callbackData()->callback();
}

} // namespace WebCore
