/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSShadowRootInit.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertEnumeration.h"
#include "JSShadowRootMode.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> ShadowRootInit convertDictionary<ShadowRootInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    ShadowRootInit result;
    JSValue delegatesFocusValue;
    if (isNullOrUndefined)
        delegatesFocusValue = jsUndefined();
    else {
        delegatesFocusValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "delegatesFocus"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!delegatesFocusValue.isUndefined()) {
        result.delegatesFocus = convert<IDLBoolean>(lexicalGlobalObject, delegatesFocusValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.delegatesFocus = false;
    JSValue modeValue;
    if (isNullOrUndefined)
        modeValue = jsUndefined();
    else {
        modeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "mode"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!modeValue.isUndefined()) {
        result.mode = convert<IDLEnumeration<ShadowRootMode>>(lexicalGlobalObject, modeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "mode", "ShadowRootInit", "ShadowRootMode");
        return { };
    }
    return result;
}

} // namespace WebCore
