/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSSpeechRecognitionErrorCode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(SpeechRecognitionErrorCode enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("no-speech"),
        MAKE_STATIC_STRING_IMPL("aborted"),
        MAKE_STATIC_STRING_IMPL("audio-capture"),
        MAKE_STATIC_STRING_IMPL("network"),
        MAKE_STATIC_STRING_IMPL("not-allowed"),
        MAKE_STATIC_STRING_IMPL("service-not-allowed"),
        MAKE_STATIC_STRING_IMPL("bad-grammar"),
        MAKE_STATIC_STRING_IMPL("language-not-supported"),
    };
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::NoSpeech) == 0, "SpeechRecognitionErrorCode::NoSpeech is not 0 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::Aborted) == 1, "SpeechRecognitionErrorCode::Aborted is not 1 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::AudioCapture) == 2, "SpeechRecognitionErrorCode::AudioCapture is not 2 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::Network) == 3, "SpeechRecognitionErrorCode::Network is not 3 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::NotAllowed) == 4, "SpeechRecognitionErrorCode::NotAllowed is not 4 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::ServiceNotAllowed) == 5, "SpeechRecognitionErrorCode::ServiceNotAllowed is not 5 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::BadGrammar) == 6, "SpeechRecognitionErrorCode::BadGrammar is not 6 as expected");
    static_assert(static_cast<size_t>(SpeechRecognitionErrorCode::LanguageNotSupported) == 7, "SpeechRecognitionErrorCode::LanguageNotSupported is not 7 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, SpeechRecognitionErrorCode enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<SpeechRecognitionErrorCode> parseEnumeration<SpeechRecognitionErrorCode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "no-speech")
        return SpeechRecognitionErrorCode::NoSpeech;
    if (stringValue == "aborted")
        return SpeechRecognitionErrorCode::Aborted;
    if (stringValue == "audio-capture")
        return SpeechRecognitionErrorCode::AudioCapture;
    if (stringValue == "network")
        return SpeechRecognitionErrorCode::Network;
    if (stringValue == "not-allowed")
        return SpeechRecognitionErrorCode::NotAllowed;
    if (stringValue == "service-not-allowed")
        return SpeechRecognitionErrorCode::ServiceNotAllowed;
    if (stringValue == "bad-grammar")
        return SpeechRecognitionErrorCode::BadGrammar;
    if (stringValue == "language-not-supported")
        return SpeechRecognitionErrorCode::LanguageNotSupported;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<SpeechRecognitionErrorCode>()
{
    return "\"no-speech\", \"aborted\", \"audio-capture\", \"network\", \"not-allowed\", \"service-not-allowed\", \"bad-grammar\", \"language-not-supported\"";
}

} // namespace WebCore
