/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO)

#include "JSVideoMatrixCoefficients.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(VideoMatrixCoefficients enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("rgb"),
        MAKE_STATIC_STRING_IMPL("bt709"),
        MAKE_STATIC_STRING_IMPL("bt470bg"),
        MAKE_STATIC_STRING_IMPL("smpte170m"),
    };
    static_assert(static_cast<size_t>(VideoMatrixCoefficients::Rgb) == 0, "VideoMatrixCoefficients::Rgb is not 0 as expected");
    static_assert(static_cast<size_t>(VideoMatrixCoefficients::Bt709) == 1, "VideoMatrixCoefficients::Bt709 is not 1 as expected");
    static_assert(static_cast<size_t>(VideoMatrixCoefficients::Bt470bg) == 2, "VideoMatrixCoefficients::Bt470bg is not 2 as expected");
    static_assert(static_cast<size_t>(VideoMatrixCoefficients::Smpte170m) == 3, "VideoMatrixCoefficients::Smpte170m is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, VideoMatrixCoefficients enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<VideoMatrixCoefficients> parseEnumeration<VideoMatrixCoefficients>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "rgb")
        return VideoMatrixCoefficients::Rgb;
    if (stringValue == "bt709")
        return VideoMatrixCoefficients::Bt709;
    if (stringValue == "bt470bg")
        return VideoMatrixCoefficients::Bt470bg;
    if (stringValue == "smpte170m")
        return VideoMatrixCoefficients::Smpte170m;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<VideoMatrixCoefficients>()
{
    return "\"rgb\", \"bt709\", \"bt470bg\", \"smpte170m\"";
}

} // namespace WebCore

#endif // ENABLE(VIDEO)
