/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017-2020 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "Settings.h"

#include "InspectorInstrumentation.h"
#include "Page.h"

// Default values.

#define SETTING_DEFAULT_VALUE_FOR_CSSOMViewScrollingAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_CSSOMViewSmoothScrollingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_acceleratedCompositedAnimationsEnabled true
#define SETTING_DEFAULT_VALUE_FOR_acceleratedCompositingEnabled true
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_acceleratedCompositingForFixedPositionEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_acceleratedCompositingForFixedPositionEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_acceleratedDrawingEnabled false
#if USE(CORE_IMAGE)
#define SETTING_DEFAULT_VALUE_FOR_acceleratedFiltersEnabled false
#endif
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_accentColorEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_accentColorEnabled false
#endif
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_accessHandleEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_accessHandleEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_aggressiveTileRetentionEnabled false
#define SETTING_DEFAULT_VALUE_FOR_allowContentSecurityPolicySourceStarToMatchAnyProtocol false
#define SETTING_DEFAULT_VALUE_FOR_allowCrossOriginSubresourcesToAskForCredentials false
#define SETTING_DEFAULT_VALUE_FOR_allowDisplayOfInsecureContent false
#define SETTING_DEFAULT_VALUE_FOR_allowFileAccessFromFileURLs true
#define SETTING_DEFAULT_VALUE_FOR_allowMediaContentTypesRequiringHardwareSupportAsFallback false
#define SETTING_DEFAULT_VALUE_FOR_allowMultiElementImplicitSubmission false
#define SETTING_DEFAULT_VALUE_FOR_allowRunningOfInsecureContent false
#define SETTING_DEFAULT_VALUE_FOR_allowSettingAnyXHRHeaderFromFileURLs false
#define SETTING_DEFAULT_VALUE_FOR_allowTopNavigationToDataURLs false
#define SETTING_DEFAULT_VALUE_FOR_allowUniversalAccessFromFileURLs true
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_allowViewportShrinkToFitContent true
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
#define SETTING_DEFAULT_VALUE_FOR_allowsAirPlayForMediaPlayback true
#endif
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_allowsInlineMediaPlayback false
#else
#define SETTING_DEFAULT_VALUE_FOR_allowsInlineMediaPlayback true
#endif
#define SETTING_DEFAULT_VALUE_FOR_allowsInlineMediaPlaybackAfterFullscreen true
#define SETTING_DEFAULT_VALUE_FOR_allowsPictureInPictureMediaPlayback true
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_alternateFormControlDesignEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_alwaysUseAcceleratedOverflowScroll false
#define SETTING_DEFAULT_VALUE_FOR_animatedImageAsyncDecodingEnabled true
#define SETTING_DEFAULT_VALUE_FOR_animatedImageDebugCanvasDrawingEnabled false
#if ENABLE(APP_HIGHLIGHTS)
#define SETTING_DEFAULT_VALUE_FOR_appHighlightsEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_appleMailPaginationQuirkEnabled false
#if ENABLE(APPLE_PAY)
#define SETTING_DEFAULT_VALUE_FOR_applePayCapabilityDisclosureAllowed true
#endif
#if ENABLE(APPLE_PAY)
#if ENABLE(APPLE_PAY_REMOTE_UI)
#define SETTING_DEFAULT_VALUE_FOR_applePayEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_applePayEnabled false
#endif
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
#define SETTING_DEFAULT_VALUE_FOR_applePayRemoteUIEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_aspectRatioEnabled true
#define SETTING_DEFAULT_VALUE_FOR_aspectRatioOfImgFromWidthAndHeightEnabled true
#define SETTING_DEFAULT_VALUE_FOR_asyncClipboardAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_asyncFrameScrollingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_asyncOverflowScrollingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_asynchronousSpellCheckingEnabled false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_audioPlaybackRequiresUserGesture true
#else
#define SETTING_DEFAULT_VALUE_FOR_audioPlaybackRequiresUserGesture false
#endif
#define SETTING_DEFAULT_VALUE_FOR_authorAndUserStylesEnabled true
#define SETTING_DEFAULT_VALUE_FOR_autoscrollForDragAndDropEnabled false
#define SETTING_DEFAULT_VALUE_FOR_backForwardCacheExpirationInterval 30_min
#define SETTING_DEFAULT_VALUE_FOR_backgroundShouldExtendBeyondPage false
#define SETTING_DEFAULT_VALUE_FOR_backspaceKeyNavigationEnabled true
#define SETTING_DEFAULT_VALUE_FOR_beaconAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_blankAnchorTargetImpliesNoOpenerEnabled true
#define SETTING_DEFAULT_VALUE_FOR_broadcastChannelEnabled true
#define SETTING_DEFAULT_VALUE_FOR_broadcastChannelOriginPartitioningEnabled true
#define SETTING_DEFAULT_VALUE_FOR_canvasColorSpaceEnabled false
#define SETTING_DEFAULT_VALUE_FOR_canvasUsesAcceleratedDrawing false
#define SETTING_DEFAULT_VALUE_FOR_caretBrowsingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_clientCoordinatesRelativeToLayoutViewport false
#define SETTING_DEFAULT_VALUE_FOR_clipboardAccessPolicy ClipboardAccessPolicy::RequiresUserGesture
#define SETTING_DEFAULT_VALUE_FOR_colorFilterEnabled false
#define SETTING_DEFAULT_VALUE_FOR_constantPropertiesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_contactPickerAPIEnabled false
#if ENABLE(CONTENT_CHANGE_OBSERVER)
#if PLATFORM(IOS_FAMILY) && !PLATFORM(MACCATALYST)
#define SETTING_DEFAULT_VALUE_FOR_contentChangeObserverEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_contentChangeObserverEnabled false
#endif
#endif
#define SETTING_DEFAULT_VALUE_FOR_contentDispositionAttachmentSandboxEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cookieConsentAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cookieEnabled true
#define SETTING_DEFAULT_VALUE_FOR_coreMathMLEnabled false
#define SETTING_DEFAULT_VALUE_FOR_crossOriginCheckInGetMatchedCSSRulesDisabled false
#define SETTING_DEFAULT_VALUE_FOR_crossOriginEmbedderPolicyEnabled false
#define SETTING_DEFAULT_VALUE_FOR_crossOriginOpenerPolicyEnabled false
#define SETTING_DEFAULT_VALUE_FOR_css3DTransformInteroperabilityEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssCascadeLayersEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssColor4 true
#define SETTING_DEFAULT_VALUE_FOR_cssColorContrastEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssColorMixEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssContainerQueriesEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssContainmentEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssCounterStyleAtRuleImageSymbolsEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssCounterStyleAtRulesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssCustomPropertiesAndValuesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssGradientInterpolationColorSpacesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssGradientPremultipliedAlphaInterpolationEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssIndividualTransformPropertiesEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssInputSecurityEnabled false
#define SETTING_DEFAULT_VALUE_FOR_cssMotionPathEnabled true
#define SETTING_DEFAULT_VALUE_FOR_cssRelativeColorSyntaxEnabled false
#if ENABLE(CSS_TRANSFORM_STYLE_OPTIMIZED_3D)
#define SETTING_DEFAULT_VALUE_FOR_cssTransformStyleOptimized3DEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_cursiveFontFamily ""
#if ENABLE(DATA_DETECTION)
#define SETTING_DEFAULT_VALUE_FOR_dataDetectorTypes DataDetectorType::None
#endif
#define SETTING_DEFAULT_VALUE_FOR_dataTransferItemsEnabled false
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
#define SETTING_DEFAULT_VALUE_FOR_dateTimeInputsEditableComponentsEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_defaultFixedFontSize 13
#define SETTING_DEFAULT_VALUE_FOR_defaultFontSize 16
#define SETTING_DEFAULT_VALUE_FOR_defaultTextEncodingName { }
#define SETTING_DEFAULT_VALUE_FOR_defaultVideoPosterURL { }
#define SETTING_DEFAULT_VALUE_FOR_deferredCSSParserEnabled false
#define SETTING_DEFAULT_VALUE_FOR_developerExtrasEnabled false
#define SETTING_DEFAULT_VALUE_FOR_deviceHeight 0
#if ENABLE(DEVICE_ORIENTATION)
#define SETTING_DEFAULT_VALUE_FOR_deviceOrientationEventEnabled true
#endif
#if ENABLE(DEVICE_ORIENTATION)
#define SETTING_DEFAULT_VALUE_FOR_deviceOrientationPermissionAPIEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_deviceWidth 0
#define SETTING_DEFAULT_VALUE_FOR_diagnosticLoggingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_dialogElementEnabled true
#define SETTING_DEFAULT_VALUE_FOR_disableScreenSizeOverride false
#define SETTING_DEFAULT_VALUE_FOR_disabledAdaptationsMetaTagEnabled false
#define SETTING_DEFAULT_VALUE_FOR_disallowSyncXHRDuringPageDismissalEnabled true
#define SETTING_DEFAULT_VALUE_FOR_displayListDrawingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_dnsPrefetchingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_domPasteAccessRequestsEnabled false
#define SETTING_DEFAULT_VALUE_FOR_domPasteAllowed false
#define SETTING_DEFAULT_VALUE_FOR_domTimersThrottlingEnabled true
#if ENABLE(DOWNLOAD_ATTRIBUTE)
#define SETTING_DEFAULT_VALUE_FOR_downloadAttributeEnabled false
#endif
#if PLATFORM(WATCHOS)
#define SETTING_DEFAULT_VALUE_FOR_downloadableBinaryFontsEnabled false
#else
#define SETTING_DEFAULT_VALUE_FOR_downloadableBinaryFontsEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_editableLinkBehavior EditableLinkBehavior::Default
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_editingBehaviorType EditingBehaviorType::iOS
#elif OS(DARWIN)
#define SETTING_DEFAULT_VALUE_FOR_editingBehaviorType EditingBehaviorType::Mac
#elif OS(WINDOWS)
#define SETTING_DEFAULT_VALUE_FOR_editingBehaviorType EditingBehaviorType::Windows
#elif OS(UNIX)
#define SETTING_DEFAULT_VALUE_FOR_editingBehaviorType EditingBehaviorType::Unix
#else
#define SETTING_DEFAULT_VALUE_FOR_editingBehaviorType EditingBehaviorType::Mac
#endif
#define SETTING_DEFAULT_VALUE_FOR_enableInheritURIQueryComponent false
#if ENABLE(ENCRYPTED_MEDIA)
#define SETTING_DEFAULT_VALUE_FOR_encryptedMediaAPIEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_enterKeyHintEnabled false
#define SETTING_DEFAULT_VALUE_FOR_eventHandlerDrivenSmoothKeyboardScrollingEnabled false
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_exposeSpeakersEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_fantasyFontFamily ""
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_fileSystemAccessEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_fileSystemAccessEnabled false
#endif
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_fixedBackgroundsPaintRelativeToDocument true
#else
#define SETTING_DEFAULT_VALUE_FOR_fixedBackgroundsPaintRelativeToDocument false
#endif
#define SETTING_DEFAULT_VALUE_FOR_fixedElementsLayoutRelativeToFrame false
#define SETTING_DEFAULT_VALUE_FOR_fixedFontFamily ""
#define SETTING_DEFAULT_VALUE_FOR_focusVisibleEnabled true
#define SETTING_DEFAULT_VALUE_FOR_fontFallbackPrefersPictographs false
#define SETTING_DEFAULT_VALUE_FOR_fontLoadTimingOverride FontLoadTimingOverride::None
#define SETTING_DEFAULT_VALUE_FOR_fontRenderingMode FontRenderingMode::Normal
#define SETTING_DEFAULT_VALUE_FOR_forceCompositingMode false
#define SETTING_DEFAULT_VALUE_FOR_forceFTPDirectoryListings false
#define SETTING_DEFAULT_VALUE_FOR_forcePendingWebGLPolicy false
#define SETTING_DEFAULT_VALUE_FOR_forceWebGLUsesLowPower false
#define SETTING_DEFAULT_VALUE_FOR_forcedColorsAreInvertedAccessibilityValue ForcedAccessibilityValue::System
#define SETTING_DEFAULT_VALUE_FOR_forcedDisplayIsMonochromeAccessibilityValue ForcedAccessibilityValue::System
#define SETTING_DEFAULT_VALUE_FOR_forcedPrefersContrastAccessibilityValue ForcedAccessibilityValue::System
#define SETTING_DEFAULT_VALUE_FOR_forcedPrefersReducedMotionAccessibilityValue ForcedAccessibilityValue::System
#define SETTING_DEFAULT_VALUE_FOR_forcedSupportsHighDynamicRangeValue ForcedAccessibilityValue::System
#define SETTING_DEFAULT_VALUE_FOR_frameFlattening FrameFlattening::Disabled
#define SETTING_DEFAULT_VALUE_FOR_ftpDirectoryTemplatePath ""
#define SETTING_DEFAULT_VALUE_FOR_ftpEnabled false
#if ENABLE(FULLSCREEN_API)
#define SETTING_DEFAULT_VALUE_FOR_fullScreenEnabled false
#endif
#if ENABLE(GAMEPAD)
#define SETTING_DEFAULT_VALUE_FOR_gamepadsEnabled false
#endif
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_genericCueAPIEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_geolocationFloorLevelEnabled true
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_getUserMediaRequiresFocus true
#endif
#define SETTING_DEFAULT_VALUE_FOR_googleAntiFlickerOptimizationQuirkEnabled true
#define SETTING_DEFAULT_VALUE_FOR_hasPseudoClassEnabled true
#define SETTING_DEFAULT_VALUE_FOR_hdrMediaCapabilitiesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_hiddenPageCSSAnimationSuspensionEnabled false
#define SETTING_DEFAULT_VALUE_FOR_hiddenPageDOMTimerThrottlingAutoIncreases false
#define SETTING_DEFAULT_VALUE_FOR_hiddenPageDOMTimerThrottlingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_htmlParserScriptingFlagPolicy HTMLParserScriptingFlagPolicy::OnlyIfScriptIsEnabled
#define SETTING_DEFAULT_VALUE_FOR_httpEquivEnabled true
#define SETTING_DEFAULT_VALUE_FOR_hyperlinkAuditingEnabled false
#if ENABLE(IOS_FORM_CONTROL_REFRESH)
#define SETTING_DEFAULT_VALUE_FOR_iOSFormControlRefreshEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_iceCandidateFilteringEnabled true
#if ENABLE(TEXT_AUTOSIZING)
#define SETTING_DEFAULT_VALUE_FOR_idempotentModeAutosizingOnlyHonorsPercentages false
#endif
#if ENABLE(IMAGE_ANALYSIS)
#define SETTING_DEFAULT_VALUE_FOR_imageAnalysisMarkupEnabled false
#endif
#if ENABLE(IMAGE_ANALYSIS)
#define SETTING_DEFAULT_VALUE_FOR_imageAnalysisQueueEnabled false
#endif
#if ENABLE(SERVICE_CONTROLS)
#define SETTING_DEFAULT_VALUE_FOR_imageControlsEnabled false
#endif
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_imageSubsamplingEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_imageSubsamplingEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_imagesEnabled true
#define SETTING_DEFAULT_VALUE_FOR_inProcessCookieCacheEnabled false
#define SETTING_DEFAULT_VALUE_FOR_incompleteImageBorderEnabled false
#define SETTING_DEFAULT_VALUE_FOR_incrementalRenderingSuppressionTimeoutInSeconds 5
#define SETTING_DEFAULT_VALUE_FOR_inertAttributeEnabled false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_inlineMediaPlaybackRequiresPlaysInlineAttribute true
#else
#define SETTING_DEFAULT_VALUE_FOR_inlineMediaPlaybackRequiresPlaysInlineAttribute false
#endif
#if ENABLE(INPUT_TYPE_COLOR)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeColorEnabled false
#endif
#if ENABLE(INPUT_TYPE_DATE)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeDateEnabled false
#endif
#if ENABLE(INPUT_TYPE_DATETIMELOCAL)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeDateTimeLocalEnabled false
#endif
#if ENABLE(INPUT_TYPE_MONTH)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeMonthEnabled false
#endif
#if ENABLE(INPUT_TYPE_TIME)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeTimeEnabled false
#endif
#if ENABLE(INPUT_TYPE_WEEK)
#define SETTING_DEFAULT_VALUE_FOR_inputTypeWeekEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_interactiveFormValidationEnabled false
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_interruptAudioOnPageVisibilityChangeEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_intersectionObserverEnabled false
#define SETTING_DEFAULT_VALUE_FOR_invisibleAutoplayNotPermitted false
#if USE(ATSPI)
#define SETTING_DEFAULT_VALUE_FOR_isAccessibilityIsolatedTreeEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isAccessibilityIsolatedTreeEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalDisabled false
#define SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalReproTestingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_isLoggedInAPIEnabled false
#if PLATFORM(MAC)
#define SETTING_DEFAULT_VALUE_FOR_isPerActivityStateCPUUsageMeasurementEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isPerActivityStateCPUUsageMeasurementEnabled false
#endif
#if PLATFORM(MAC)
#define SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingCPUUsageMeasurementEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingCPUUsageMeasurementEnabled false
#endif
#if PLATFORM(MAC)
#define SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingMemoryUsageMeasurementEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingMemoryUsageMeasurementEnabled false
#endif
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_isPostLoadCPUUsageMeasurementEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isPostLoadCPUUsageMeasurementEnabled false
#endif
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_isPostLoadMemoryUsageMeasurementEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_isPostLoadMemoryUsageMeasurementEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_isSameSiteStrictEnforcementEnabled false
#define SETTING_DEFAULT_VALUE_FOR_isThirdPartyCookieBlockingDisabled false
#define SETTING_DEFAULT_VALUE_FOR_javaEnabled false
#define SETTING_DEFAULT_VALUE_FOR_javaEnabledForLocalFiles true
#define SETTING_DEFAULT_VALUE_FOR_javaScriptCanAccessClipboard false
#define SETTING_DEFAULT_VALUE_FOR_javaScriptCanOpenWindowsAutomatically false
#define SETTING_DEFAULT_VALUE_FOR_javaScriptRuntimeFlags { }
#define SETTING_DEFAULT_VALUE_FOR_langAttributeAwareFormControlUIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_largeImageAsyncDecodingEnabled true
#if ENABLE(LAYER_BASED_SVG_ENGINE)
#define SETTING_DEFAULT_VALUE_FOR_layerBasedSVGEngineEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_layoutFallbackWidth 980
#define SETTING_DEFAULT_VALUE_FOR_layoutViewportHeightExpansionFactor 0
#define SETTING_DEFAULT_VALUE_FOR_lazyIframeLoadingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_lazyImageLoadingEnabled false
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
#define SETTING_DEFAULT_VALUE_FOR_legacyEncryptedMediaAPIEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_legacyLineLayoutVisualCoverageEnabled false
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
#define SETTING_DEFAULT_VALUE_FOR_legacyOverflowScrollingTouchEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_linkPreconnectEnabled false
#define SETTING_DEFAULT_VALUE_FOR_linkPrefetchEnabled false
#define SETTING_DEFAULT_VALUE_FOR_linkPreloadEnabled true
#define SETTING_DEFAULT_VALUE_FOR_linkPreloadResponsiveImagesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_linkSanitizerEnabled false
#define SETTING_DEFAULT_VALUE_FOR_liveRangeSelectionEnabled false
#define SETTING_DEFAULT_VALUE_FOR_loadDeferringEnabled true
#define SETTING_DEFAULT_VALUE_FOR_loadsImagesAutomatically false
#define SETTING_DEFAULT_VALUE_FOR_loadsSiteIconsIgnoringImageLoadingSetting false
#define SETTING_DEFAULT_VALUE_FOR_localFileContentSniffingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_localStorageDatabasePath { }
#define SETTING_DEFAULT_VALUE_FOR_localStorageEnabled false
#define SETTING_DEFAULT_VALUE_FOR_logsPageMessagesToSystemConsoleEnabled false
#define SETTING_DEFAULT_VALUE_FOR_mainContentUserGestureOverrideEnabled false
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
#define SETTING_DEFAULT_VALUE_FOR_maskWebGLStringsEnabled true
#endif
#if ENABLE(MATHML)
#define SETTING_DEFAULT_VALUE_FOR_mathMLEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_maxParseDuration -1
#define SETTING_DEFAULT_VALUE_FOR_maximumAccelerated2dCanvasSize 5120*2880
#define SETTING_DEFAULT_VALUE_FOR_maximumHTMLParserDOMTreeDepth defaultMaximumHTMLParserDOMTreeDepth
#if ENABLE(MEDIA_SOURCE)
#define SETTING_DEFAULT_VALUE_FOR_maximumSourceBufferSize 318767104
#endif
#define SETTING_DEFAULT_VALUE_FOR_mediaCapabilitiesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_mediaCapabilitiesExtensionsEnabled false
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_mediaCaptureRequiresSecureConnection true
#endif
#define SETTING_DEFAULT_VALUE_FOR_mediaContentTypesRequiringHardwareSupport ""
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
#define SETTING_DEFAULT_VALUE_FOR_mediaControlsContextMenusEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_mediaControlsScaleWithPageZoom true
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_mediaDataLoadsAutomatically false
#else
#define SETTING_DEFAULT_VALUE_FOR_mediaDataLoadsAutomatically true
#endif
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_mediaDeviceIdentifierStorageDirectory { }
#endif
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_mediaDevicesEnabled false
#endif
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_mediaEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_mediaKeysStorageDirectory { }
#define SETTING_DEFAULT_VALUE_FOR_mediaPreloadingEnabled false
#if ENABLE(MEDIA_RECORDER)
#define SETTING_DEFAULT_VALUE_FOR_mediaRecorderEnabled false
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR)
#define SETTING_DEFAULT_VALUE_FOR_mediaSessionCoordinatorEnabled true
#endif
#if ENABLE(MEDIA_SESSION)
#define SETTING_DEFAULT_VALUE_FOR_mediaSessionEnabled true
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR) && ENABLE(MEDIA_SESSION_PLAYLIST)
#define SETTING_DEFAULT_VALUE_FOR_mediaSessionPlaylistEnabled true
#endif
#if ENABLE(MEDIA_SOURCE)
#define SETTING_DEFAULT_VALUE_FOR_mediaSourceEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_mediaSourceEnabled false
#endif
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_mediaStreamEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_mediaTypeOverride "screen"
#define SETTING_DEFAULT_VALUE_FOR_mediaUserGestureInheritsFromDocument false
#define SETTING_DEFAULT_VALUE_FOR_minimumAccelerated2dCanvasSize 257*256
#define SETTING_DEFAULT_VALUE_FOR_minimumFontSize 0
#define SETTING_DEFAULT_VALUE_FOR_minimumLogicalFontSize 0
#if ENABLE(TEXT_AUTOSIZING)
#if PLATFORM(WATCHOS)
#define SETTING_DEFAULT_VALUE_FOR_minimumZoomFontSize 30
#else
#define SETTING_DEFAULT_VALUE_FOR_minimumZoomFontSize 15
#endif
#endif
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_mockCaptureDevicesEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_mockScrollbarsControllerEnabled false
#if ENABLE(MODEL_ELEMENT)
#define SETTING_DEFAULT_VALUE_FOR_modelElementEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_momentumScrollingAnimatorEnabled false
#define SETTING_DEFAULT_VALUE_FOR_needsAdobeFrameReloadingQuirk false
#define SETTING_DEFAULT_VALUE_FOR_needsDeferKeyDownAndKeyPressTimersUntilNextEditingCommandQuirk false
#define SETTING_DEFAULT_VALUE_FOR_needsFrameNameFallbackToIdQuirk false
#define SETTING_DEFAULT_VALUE_FOR_needsKeyboardEventDisambiguationQuirks false
#define SETTING_DEFAULT_VALUE_FOR_needsSiteSpecificQuirks false
#define SETTING_DEFAULT_VALUE_FOR_needsStorageAccessFromFileURLsQuirk true
#if ENABLE(NOTIFICATIONS)
#define SETTING_DEFAULT_VALUE_FOR_notificationsEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_offlineWebApplicationCacheEnabled false
#define SETTING_DEFAULT_VALUE_FOR_overflowClipEnabled true
#if PLATFORM(WIN) || PLATFORM(GTK) || PLATFORM(WPE)
#define SETTING_DEFAULT_VALUE_FOR_overscrollBehaviorEnabled false
#else
#define SETTING_DEFAULT_VALUE_FOR_overscrollBehaviorEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_paginateDuringLayoutEnabled false
#define SETTING_DEFAULT_VALUE_FOR_passiveTouchListenersAsDefaultOnDocument true
#define SETTING_DEFAULT_VALUE_FOR_passiveWheelListenersAsDefaultOnDocument true
#define SETTING_DEFAULT_VALUE_FOR_passwordEchoDurationInSeconds 1
#define SETTING_DEFAULT_VALUE_FOR_passwordEchoEnabled false
#if ENABLE(PAYMENT_REQUEST)
#define SETTING_DEFAULT_VALUE_FOR_paymentRequestEnabled false
#endif
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_pdfImageCachingPolicy PDFImageCachingPolicy::BelowMemoryLimit
#else
#define SETTING_DEFAULT_VALUE_FOR_pdfImageCachingPolicy PDFImageCachingPolicy::Enabled
#endif
#define SETTING_DEFAULT_VALUE_FOR_pdfJSViewerEnabled false
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_peerConnectionEnabled true
#endif
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_perElementSpeakerSelectionEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_performanceNavigationTimingAPIEnabled true
#define SETTING_DEFAULT_VALUE_FOR_performanceResourceTimingSensitivePropertiesEnabled false
#define SETTING_DEFAULT_VALUE_FOR_permissionsAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_pictographFontFamily ""
#if ENABLE(PICTURE_IN_PICTURE_API)
#define SETTING_DEFAULT_VALUE_FOR_pictureInPictureAPIEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_pitchCorrectionAlgorithm MediaPlayerEnums::PitchCorrectionAlgorithm::BestAllAround
#define SETTING_DEFAULT_VALUE_FOR_pluginsEnabled false
#if ENABLE(IMAGE_ANALYSIS)
#if HAVE(UIKIT_WEBKIT_INTERNALS)
#define SETTING_DEFAULT_VALUE_FOR_preferInlineTextSelectionInImages false
#else
#define SETTING_DEFAULT_VALUE_FOR_preferInlineTextSelectionInImages true
#endif
#endif
#define SETTING_DEFAULT_VALUE_FOR_preferMIMETypeForImages false
#define SETTING_DEFAULT_VALUE_FOR_preferPageRenderingUpdatesNear60FPSEnabled true
#define SETTING_DEFAULT_VALUE_FOR_preventKeyboardDOMEventDispatch false
#define SETTING_DEFAULT_VALUE_FOR_privateClickMeasurementEnabled true
#if HAVE(RSA_BSSA)
#define SETTING_DEFAULT_VALUE_FOR_privateClickMeasurementFraudPreventionEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_privateClickMeasurementFraudPreventionEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_punchOutWhiteBackgroundsInDarkMode false
#define SETTING_DEFAULT_VALUE_FOR_referrerPolicyAttributeEnabled true
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
#define SETTING_DEFAULT_VALUE_FOR_remotePlaybackEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_repaintOutsideLayoutEnabled false
#define SETTING_DEFAULT_VALUE_FOR_requestIdleCallbackEnabled false
#define SETTING_DEFAULT_VALUE_FOR_requestSubmitEnabled true
#if PLATFORM(COCOA) && HAVE(AVSAMPLEBUFFERVIDEOOUTPUT)
#define SETTING_DEFAULT_VALUE_FOR_requestVideoFrameCallbackEnabled true
#elif USE(GSTREAMER)
#define SETTING_DEFAULT_VALUE_FOR_requestVideoFrameCallbackEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_requestVideoFrameCallbackEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_requiresPageVisibilityToPlayAudio false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_requiresUserGestureToLoadVideo true
#else
#define SETTING_DEFAULT_VALUE_FOR_requiresUserGestureToLoadVideo false
#endif
#define SETTING_DEFAULT_VALUE_FOR_resizeObserverEnabled false
#define SETTING_DEFAULT_VALUE_FOR_resolutionMediaFeatureEnabled true
#define SETTING_DEFAULT_VALUE_FOR_resourceLoadSchedulingEnabled true
#if ENABLE(RESOURCE_USAGE)
#define SETTING_DEFAULT_VALUE_FOR_resourceUsageOverlayVisible false
#endif
#if HAVE(RUBBER_BANDING)
#define SETTING_DEFAULT_VALUE_FOR_rubberBandingForSubScrollableRegionsEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_sampledPageTopColorMaxDifference 0
#define SETTING_DEFAULT_VALUE_FOR_sampledPageTopColorMinHeight 0
#define SETTING_DEFAULT_VALUE_FOR_sansSerifFontFamily ""
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_screenCaptureEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_scriptEnabled false
#define SETTING_DEFAULT_VALUE_FOR_scriptMarkupEnabled true
#define SETTING_DEFAULT_VALUE_FOR_scrollAnimatorEnabled false
#define SETTING_DEFAULT_VALUE_FOR_scrollToTextFragmentEnabled false
#define SETTING_DEFAULT_VALUE_FOR_scrollingCoordinatorEnabled false
#define SETTING_DEFAULT_VALUE_FOR_scrollingPerformanceTestingEnabled false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_scrollingTreeIncludesFrames true
#else
#define SETTING_DEFAULT_VALUE_FOR_scrollingTreeIncludesFrames false
#endif
#define SETTING_DEFAULT_VALUE_FOR_selectTrailingWhitespaceEnabled false
#define SETTING_DEFAULT_VALUE_FOR_selectionPaintingWithoutSelectionGapsEnabled false
#define SETTING_DEFAULT_VALUE_FOR_serifFontFamily ""
#if ENABLE(SERVICE_CONTROLS)
#define SETTING_DEFAULT_VALUE_FOR_serviceControlsEnabled false
#endif
#if ENABLE(SERVICE_WORKER)
#define SETTING_DEFAULT_VALUE_FOR_serviceWorkerNavigationPreloadEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_sessionStorageQuota 5242880
#define SETTING_DEFAULT_VALUE_FOR_sharedWorkerEnabled false
#define SETTING_DEFAULT_VALUE_FOR_shouldAllowUserInstalledFonts true
#define SETTING_DEFAULT_VALUE_FOR_shouldConvertInvalidURLsToBlank true
#define SETTING_DEFAULT_VALUE_FOR_shouldConvertPositionStyleOnCopy false
#define SETTING_DEFAULT_VALUE_FOR_shouldDecidePolicyBeforeLoadingQuickLookPreview false
#define SETTING_DEFAULT_VALUE_FOR_shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint true
#define SETTING_DEFAULT_VALUE_FOR_shouldDispatchSyntheticMouseEventsWhenModifyingSelection false
#define SETTING_DEFAULT_VALUE_FOR_shouldDispatchSyntheticMouseOutAfterSyntheticClick false
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_shouldDisplayCaptions false
#endif
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_shouldDisplaySubtitles false
#endif
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_shouldDisplayTextDescriptions false
#endif
#if ENABLE(TEXT_AUTOSIZING)
#define SETTING_DEFAULT_VALUE_FOR_shouldEnableTextAutosizingBoost false
#endif
#define SETTING_DEFAULT_VALUE_FOR_shouldIgnoreFontLoadCompletions false
#define SETTING_DEFAULT_VALUE_FOR_shouldIgnoreMetaViewport false
#define SETTING_DEFAULT_VALUE_FOR_shouldInjectUserScriptsInInitialEmptyDocument false
#define SETTING_DEFAULT_VALUE_FOR_shouldPrintBackgrounds false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_shouldRespectImageOrientation true
#else
#define SETTING_DEFAULT_VALUE_FOR_shouldRespectImageOrientation false
#endif
#define SETTING_DEFAULT_VALUE_FOR_shouldRestrictBaseURLSchemes true
#define SETTING_DEFAULT_VALUE_FOR_shouldSuppressTextInputFromEditingDuringProvisionalNavigation false
#define SETTING_DEFAULT_VALUE_FOR_shouldUseServiceWorkerShortTimeout false
#define SETTING_DEFAULT_VALUE_FOR_showDebugBorders false
#define SETTING_DEFAULT_VALUE_FOR_showRepaintCounter false
#define SETTING_DEFAULT_VALUE_FOR_showTiledScrollingIndicator false
#define SETTING_DEFAULT_VALUE_FOR_showsToolTipOverTruncatedText false
#define SETTING_DEFAULT_VALUE_FOR_showsURLsInToolTips false
#define SETTING_DEFAULT_VALUE_FOR_shrinksStandaloneImagesToFit true
#define SETTING_DEFAULT_VALUE_FOR_simpleLineLayoutEnabled true
#define SETTING_DEFAULT_VALUE_FOR_smartInsertDeleteEnabled true
#if ENABLE(MEDIA_SOURCE)
#define SETTING_DEFAULT_VALUE_FOR_sourceBufferChangeTypeEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_spatialNavigationEnabled false
#if ENABLE(MEDIA_STREAM)
#define SETTING_DEFAULT_VALUE_FOR_speakerSelectionRequiresUserGesture true
#endif
#define SETTING_DEFAULT_VALUE_FOR_speechRecognitionEnabled false
#define SETTING_DEFAULT_VALUE_FOR_springTimingFunctionEnabled false
#define SETTING_DEFAULT_VALUE_FOR_standalone false
#define SETTING_DEFAULT_VALUE_FOR_standardFontFamily ""
#if PLATFORM(COCOA)
#define SETTING_DEFAULT_VALUE_FOR_storageAPIEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_storageAPIEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_storageAccessAPIEnabled true
#define SETTING_DEFAULT_VALUE_FOR_storageAccessAPIPerPageScopeEnabled true
#define SETTING_DEFAULT_VALUE_FOR_storageBlockingPolicy StorageBlockingPolicy::AllowAll
#define SETTING_DEFAULT_VALUE_FOR_subgridEnabled true
#define SETTING_DEFAULT_VALUE_FOR_subpixelAntialiasedLayerTextEnabled false
#define SETTING_DEFAULT_VALUE_FOR_suppressesIncrementalRendering false
#define SETTING_DEFAULT_VALUE_FOR_syntheticEditingCommandsEnabled true
#define SETTING_DEFAULT_VALUE_FOR_systemLayoutDirection TextDirection::LTR
#if USE(SYSTEM_PREVIEW)
#define SETTING_DEFAULT_VALUE_FOR_systemPreviewEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_telephoneNumberParsingEnabled false
#define SETTING_DEFAULT_VALUE_FOR_temporaryTileCohortRetentionEnabled true
#define SETTING_DEFAULT_VALUE_FOR_textAreasAreResizable false
#if ENABLE(TEXT_AUTOSIZING)
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_textAutosizingEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_textAutosizingEnabled false
#endif
#endif
#if ENABLE(TEXT_AUTOSIZING)
#define SETTING_DEFAULT_VALUE_FOR_textAutosizingUsesIdempotentMode false
#endif
#if ENABLE(TEXT_AUTOSIZING)
#define SETTING_DEFAULT_VALUE_FOR_textAutosizingWindowSizeOverrideHeight 0
#endif
#if ENABLE(TEXT_AUTOSIZING)
#define SETTING_DEFAULT_VALUE_FOR_textAutosizingWindowSizeOverrideWidth 0
#endif
#define SETTING_DEFAULT_VALUE_FOR_textDirectionSubmenuInclusionBehavior TextDirectionSubmenuInclusionBehavior::AutomaticallyIncluded
#if PLATFORM(WATCHOS)
#define SETTING_DEFAULT_VALUE_FOR_textInteractionEnabled false
#else
#define SETTING_DEFAULT_VALUE_FOR_textInteractionEnabled true
#endif
#if ENABLE(IMAGE_ANALYSIS)
#define SETTING_DEFAULT_VALUE_FOR_textRecognitionEnhancementsEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_thirdPartyIframeRedirectBlockingEnabled true
#define SETTING_DEFAULT_VALUE_FOR_timeWithoutMouseMovementBeforeHidingControls 3_s
#if ENABLE(TOUCH_EVENTS)
#define SETTING_DEFAULT_VALUE_FOR_touchEventEmulationEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_trackConfigurationEnabled false
#define SETTING_DEFAULT_VALUE_FOR_transformStreamAPIEnabled true
#define SETTING_DEFAULT_VALUE_FOR_treatIPAddressAsDomain false
#define SETTING_DEFAULT_VALUE_FOR_treatsAnyTextCSSLinkAsStylesheet false
#define SETTING_DEFAULT_VALUE_FOR_undoManagerAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_unhandledPromiseRejectionToConsoleEnabled true
#if USE(UNIFIED_TEXT_CHECKING)
#define SETTING_DEFAULT_VALUE_FOR_unifiedTextCheckerEnabled true
#else
#define SETTING_DEFAULT_VALUE_FOR_unifiedTextCheckerEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_useAnonymousModeWhenFetchingMaskImages true
#define SETTING_DEFAULT_VALUE_FOR_useGiantTiles false
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_useImageDocumentForSubframePDF true
#else
#define SETTING_DEFAULT_VALUE_FOR_useImageDocumentForSubframePDF false
#endif
#define SETTING_DEFAULT_VALUE_FOR_useLegacyBackgroundSizeShorthandBehavior false
#define SETTING_DEFAULT_VALUE_FOR_useLegacyTextAlignPositionedElementBehavior false
#define SETTING_DEFAULT_VALUE_FOR_usePreHTML5ParserQuirks false
#if HAVE(SCREEN_CAPTURE_KIT)
#define SETTING_DEFAULT_VALUE_FOR_useScreenCaptureKit false
#endif
#define SETTING_DEFAULT_VALUE_FOR_userInterfaceDirectionPolicy UserInterfaceDirectionPolicy::Content
#define SETTING_DEFAULT_VALUE_FOR_userStyleSheetLocation { }
#define SETTING_DEFAULT_VALUE_FOR_usesBackForwardCache true
#define SETTING_DEFAULT_VALUE_FOR_usesEncodingDetector false
#define SETTING_DEFAULT_VALUE_FOR_validationMessageTimerMagnification 50
#if PLATFORM(IOS_FAMILY)
#define SETTING_DEFAULT_VALUE_FOR_videoPlaybackRequiresUserGesture true
#else
#define SETTING_DEFAULT_VALUE_FOR_videoPlaybackRequiresUserGesture false
#endif
#if ENABLE(VIDEO)
#define SETTING_DEFAULT_VALUE_FOR_videoQualityIncludesDisplayCompositingEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_viewportFitEnabled false
#define SETTING_DEFAULT_VALUE_FOR_visibleDebugOverlayRegions 0
#define SETTING_DEFAULT_VALUE_FOR_visualViewportAPIEnabled false
#define SETTING_DEFAULT_VALUE_FOR_visualViewportEnabled true
#if ENABLE(VP9)
#define SETTING_DEFAULT_VALUE_FOR_vp9DecoderEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_wantsBalancedSetDefersLoadingBehavior false
#define SETTING_DEFAULT_VALUE_FOR_webAnimationsCompositeOperationsEnabled true
#define SETTING_DEFAULT_VALUE_FOR_webAnimationsCustomEffectsEnabled false
#define SETTING_DEFAULT_VALUE_FOR_webAnimationsCustomFrameRateEnabled false
#define SETTING_DEFAULT_VALUE_FOR_webAnimationsMutableTimelinesEnabled false
#if ENABLE(WEB_ARCHIVE)
#define SETTING_DEFAULT_VALUE_FOR_webArchiveDebugModeEnabled false
#endif
#if ENABLE(WEB_AUDIO)
#define SETTING_DEFAULT_VALUE_FOR_webAudioEnabled false
#endif
#if ENABLE(WEB_AUTHN)
#define SETTING_DEFAULT_VALUE_FOR_webAuthenticationEnabled true
#endif
#if ENABLE(WEBGL2)
#define SETTING_DEFAULT_VALUE_FOR_webGL2Enabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_webGLEnabled false
#define SETTING_DEFAULT_VALUE_FOR_webGLErrorsToConsoleEnabled true
#if ENABLE(WEBGL) && PLATFORM(COCOA)
#if HAVE(WEBGL_COMPATIBLE_METAL)
#define SETTING_DEFAULT_VALUE_FOR_webGLUsingMetal true
#else
#define SETTING_DEFAULT_VALUE_FOR_webGLUsingMetal false
#endif
#endif
#define SETTING_DEFAULT_VALUE_FOR_webGPU false
#define SETTING_DEFAULT_VALUE_FOR_webKitAdditionsFeature1Enabled false
#define SETTING_DEFAULT_VALUE_FOR_webLocksAPIEnabled true
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCEncodedTransformEnabled true
#endif
#define SETTING_DEFAULT_VALUE_FOR_webRTCEncryptionEnabled true
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCH265CodecEnabled false
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCPlatformCodecsInGPUProcessEnabled false
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCRemoteVideoFrameEnabled false
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCSFrameTransformEnabled false
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCSocketsProxyingEnabled false
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCVP9Profile0CodecEnabled true
#endif
#if ENABLE(WEB_RTC)
#define SETTING_DEFAULT_VALUE_FOR_webRTCVP9Profile2CodecEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_webSecurityEnabled true
#define SETTING_DEFAULT_VALUE_FOR_webShareEnabled false
#define SETTING_DEFAULT_VALUE_FOR_webShareFileAPIEnabled false
#if ENABLE(WEBXR)
#define SETTING_DEFAULT_VALUE_FOR_webXRAugmentedRealityModuleEnabled false
#endif
#if ENABLE(WEBXR)
#define SETTING_DEFAULT_VALUE_FOR_webXREnabled false
#endif
#if ENABLE(WEBXR)
#define SETTING_DEFAULT_VALUE_FOR_webXRGamepadsModuleEnabled false
#endif
#if ENABLE(WEBXR_HANDS)
#define SETTING_DEFAULT_VALUE_FOR_webXRHandInputModuleEnabled false
#endif
#define SETTING_DEFAULT_VALUE_FOR_webkitImageReadyEventEnabled false
#define SETTING_DEFAULT_VALUE_FOR_wheelEventGesturesBecomeNonBlocking true
#define SETTING_DEFAULT_VALUE_FOR_windowFocusRestricted true
#define SETTING_DEFAULT_VALUE_FOR_xssAuditorEnabled false

namespace WebCore {

Ref<Settings> Settings::create(Page* page)
{
    return adoptRef(*new Settings(page));
}

Settings::Settings(Page* page)
    : SettingsBase(page)
{
    m_values.initialize();

    m_page = nullptr; // Page is not yet fully initialized when constructing Settings, so keeping m_page null over initializeDefaultFontFamilies() call.
    initializeDefaultFontFamilies();
    m_page = page;
}

void Settings::Values::initialize()
{
    backForwardCacheExpirationInterval = SETTING_DEFAULT_VALUE_FOR_backForwardCacheExpirationInterval;
    clipboardAccessPolicy = SETTING_DEFAULT_VALUE_FOR_clipboardAccessPolicy;
    defaultFixedFontSize = SETTING_DEFAULT_VALUE_FOR_defaultFixedFontSize;
    defaultFontSize = SETTING_DEFAULT_VALUE_FOR_defaultFontSize;
    defaultTextEncodingName = SETTING_DEFAULT_VALUE_FOR_defaultTextEncodingName;
    defaultVideoPosterURL = SETTING_DEFAULT_VALUE_FOR_defaultVideoPosterURL;
    deviceHeight = SETTING_DEFAULT_VALUE_FOR_deviceHeight;
    deviceWidth = SETTING_DEFAULT_VALUE_FOR_deviceWidth;
    editableLinkBehavior = SETTING_DEFAULT_VALUE_FOR_editableLinkBehavior;
    editingBehaviorType = SETTING_DEFAULT_VALUE_FOR_editingBehaviorType;
    fontLoadTimingOverride = SETTING_DEFAULT_VALUE_FOR_fontLoadTimingOverride;
    fontRenderingMode = SETTING_DEFAULT_VALUE_FOR_fontRenderingMode;
    forcedColorsAreInvertedAccessibilityValue = SETTING_DEFAULT_VALUE_FOR_forcedColorsAreInvertedAccessibilityValue;
    forcedDisplayIsMonochromeAccessibilityValue = SETTING_DEFAULT_VALUE_FOR_forcedDisplayIsMonochromeAccessibilityValue;
    forcedPrefersContrastAccessibilityValue = SETTING_DEFAULT_VALUE_FOR_forcedPrefersContrastAccessibilityValue;
    forcedPrefersReducedMotionAccessibilityValue = SETTING_DEFAULT_VALUE_FOR_forcedPrefersReducedMotionAccessibilityValue;
    forcedSupportsHighDynamicRangeValue = SETTING_DEFAULT_VALUE_FOR_forcedSupportsHighDynamicRangeValue;
    frameFlattening = SETTING_DEFAULT_VALUE_FOR_frameFlattening;
    ftpDirectoryTemplatePath = SETTING_DEFAULT_VALUE_FOR_ftpDirectoryTemplatePath;
    htmlParserScriptingFlagPolicy = SETTING_DEFAULT_VALUE_FOR_htmlParserScriptingFlagPolicy;
    incrementalRenderingSuppressionTimeoutInSeconds = SETTING_DEFAULT_VALUE_FOR_incrementalRenderingSuppressionTimeoutInSeconds;
    javaScriptRuntimeFlags = SETTING_DEFAULT_VALUE_FOR_javaScriptRuntimeFlags;
    layoutFallbackWidth = SETTING_DEFAULT_VALUE_FOR_layoutFallbackWidth;
    layoutViewportHeightExpansionFactor = SETTING_DEFAULT_VALUE_FOR_layoutViewportHeightExpansionFactor;
    localStorageDatabasePath = SETTING_DEFAULT_VALUE_FOR_localStorageDatabasePath;
    maxParseDuration = SETTING_DEFAULT_VALUE_FOR_maxParseDuration;
    maximumAccelerated2dCanvasSize = SETTING_DEFAULT_VALUE_FOR_maximumAccelerated2dCanvasSize;
    maximumHTMLParserDOMTreeDepth = SETTING_DEFAULT_VALUE_FOR_maximumHTMLParserDOMTreeDepth;
    mediaKeysStorageDirectory = SETTING_DEFAULT_VALUE_FOR_mediaKeysStorageDirectory;
    mediaTypeOverride = SETTING_DEFAULT_VALUE_FOR_mediaTypeOverride;
    minimumAccelerated2dCanvasSize = SETTING_DEFAULT_VALUE_FOR_minimumAccelerated2dCanvasSize;
    minimumFontSize = SETTING_DEFAULT_VALUE_FOR_minimumFontSize;
    minimumLogicalFontSize = SETTING_DEFAULT_VALUE_FOR_minimumLogicalFontSize;
    passwordEchoDurationInSeconds = SETTING_DEFAULT_VALUE_FOR_passwordEchoDurationInSeconds;
    pdfImageCachingPolicy = SETTING_DEFAULT_VALUE_FOR_pdfImageCachingPolicy;
    pitchCorrectionAlgorithm = SETTING_DEFAULT_VALUE_FOR_pitchCorrectionAlgorithm;
    sampledPageTopColorMaxDifference = SETTING_DEFAULT_VALUE_FOR_sampledPageTopColorMaxDifference;
    sampledPageTopColorMinHeight = SETTING_DEFAULT_VALUE_FOR_sampledPageTopColorMinHeight;
    sessionStorageQuota = SETTING_DEFAULT_VALUE_FOR_sessionStorageQuota;
    storageBlockingPolicy = SETTING_DEFAULT_VALUE_FOR_storageBlockingPolicy;
    systemLayoutDirection = SETTING_DEFAULT_VALUE_FOR_systemLayoutDirection;
    textDirectionSubmenuInclusionBehavior = SETTING_DEFAULT_VALUE_FOR_textDirectionSubmenuInclusionBehavior;
    timeWithoutMouseMovementBeforeHidingControls = SETTING_DEFAULT_VALUE_FOR_timeWithoutMouseMovementBeforeHidingControls;
    userInterfaceDirectionPolicy = SETTING_DEFAULT_VALUE_FOR_userInterfaceDirectionPolicy;
    userStyleSheetLocation = SETTING_DEFAULT_VALUE_FOR_userStyleSheetLocation;
    validationMessageTimerMagnification = SETTING_DEFAULT_VALUE_FOR_validationMessageTimerMagnification;
    visibleDebugOverlayRegions = SETTING_DEFAULT_VALUE_FOR_visibleDebugOverlayRegions;
#if ENABLE(DATA_DETECTION)
    dataDetectorTypes = SETTING_DEFAULT_VALUE_FOR_dataDetectorTypes;
#endif
#if ENABLE(MEDIA_SOURCE)
    maximumSourceBufferSize = SETTING_DEFAULT_VALUE_FOR_maximumSourceBufferSize;
#endif
#if ENABLE(MEDIA_STREAM)
    mediaDeviceIdentifierStorageDirectory = SETTING_DEFAULT_VALUE_FOR_mediaDeviceIdentifierStorageDirectory;
#endif
#if ENABLE(TEXT_AUTOSIZING)
    minimumZoomFontSize = SETTING_DEFAULT_VALUE_FOR_minimumZoomFontSize;
    textAutosizingWindowSizeOverrideHeight = SETTING_DEFAULT_VALUE_FOR_textAutosizingWindowSizeOverrideHeight;
    textAutosizingWindowSizeOverrideWidth = SETTING_DEFAULT_VALUE_FOR_textAutosizingWindowSizeOverrideWidth;
#endif
    CSSOMViewScrollingAPIEnabled = SETTING_DEFAULT_VALUE_FOR_CSSOMViewScrollingAPIEnabled;
    CSSOMViewSmoothScrollingEnabled = SETTING_DEFAULT_VALUE_FOR_CSSOMViewSmoothScrollingEnabled;
    acceleratedCompositedAnimationsEnabled = SETTING_DEFAULT_VALUE_FOR_acceleratedCompositedAnimationsEnabled;
    acceleratedCompositingEnabled = SETTING_DEFAULT_VALUE_FOR_acceleratedCompositingEnabled;
    acceleratedCompositingForFixedPositionEnabled = SETTING_DEFAULT_VALUE_FOR_acceleratedCompositingForFixedPositionEnabled;
    acceleratedDrawingEnabled = SETTING_DEFAULT_VALUE_FOR_acceleratedDrawingEnabled;
    accentColorEnabled = SETTING_DEFAULT_VALUE_FOR_accentColorEnabled;
    accessHandleEnabled = SETTING_DEFAULT_VALUE_FOR_accessHandleEnabled;
    aggressiveTileRetentionEnabled = SETTING_DEFAULT_VALUE_FOR_aggressiveTileRetentionEnabled;
    allowContentSecurityPolicySourceStarToMatchAnyProtocol = SETTING_DEFAULT_VALUE_FOR_allowContentSecurityPolicySourceStarToMatchAnyProtocol;
    allowCrossOriginSubresourcesToAskForCredentials = SETTING_DEFAULT_VALUE_FOR_allowCrossOriginSubresourcesToAskForCredentials;
    allowDisplayOfInsecureContent = SETTING_DEFAULT_VALUE_FOR_allowDisplayOfInsecureContent;
    allowFileAccessFromFileURLs = SETTING_DEFAULT_VALUE_FOR_allowFileAccessFromFileURLs;
    allowMediaContentTypesRequiringHardwareSupportAsFallback = SETTING_DEFAULT_VALUE_FOR_allowMediaContentTypesRequiringHardwareSupportAsFallback;
    allowMultiElementImplicitSubmission = SETTING_DEFAULT_VALUE_FOR_allowMultiElementImplicitSubmission;
    allowRunningOfInsecureContent = SETTING_DEFAULT_VALUE_FOR_allowRunningOfInsecureContent;
    allowSettingAnyXHRHeaderFromFileURLs = SETTING_DEFAULT_VALUE_FOR_allowSettingAnyXHRHeaderFromFileURLs;
    allowTopNavigationToDataURLs = SETTING_DEFAULT_VALUE_FOR_allowTopNavigationToDataURLs;
    allowUniversalAccessFromFileURLs = SETTING_DEFAULT_VALUE_FOR_allowUniversalAccessFromFileURLs;
    allowsInlineMediaPlayback = SETTING_DEFAULT_VALUE_FOR_allowsInlineMediaPlayback;
    allowsInlineMediaPlaybackAfterFullscreen = SETTING_DEFAULT_VALUE_FOR_allowsInlineMediaPlaybackAfterFullscreen;
    allowsPictureInPictureMediaPlayback = SETTING_DEFAULT_VALUE_FOR_allowsPictureInPictureMediaPlayback;
    alwaysUseAcceleratedOverflowScroll = SETTING_DEFAULT_VALUE_FOR_alwaysUseAcceleratedOverflowScroll;
    animatedImageAsyncDecodingEnabled = SETTING_DEFAULT_VALUE_FOR_animatedImageAsyncDecodingEnabled;
    animatedImageDebugCanvasDrawingEnabled = SETTING_DEFAULT_VALUE_FOR_animatedImageDebugCanvasDrawingEnabled;
    appleMailPaginationQuirkEnabled = SETTING_DEFAULT_VALUE_FOR_appleMailPaginationQuirkEnabled;
    aspectRatioEnabled = SETTING_DEFAULT_VALUE_FOR_aspectRatioEnabled;
    aspectRatioOfImgFromWidthAndHeightEnabled = SETTING_DEFAULT_VALUE_FOR_aspectRatioOfImgFromWidthAndHeightEnabled;
    asyncClipboardAPIEnabled = SETTING_DEFAULT_VALUE_FOR_asyncClipboardAPIEnabled;
    asyncFrameScrollingEnabled = SETTING_DEFAULT_VALUE_FOR_asyncFrameScrollingEnabled;
    asyncOverflowScrollingEnabled = SETTING_DEFAULT_VALUE_FOR_asyncOverflowScrollingEnabled;
    asynchronousSpellCheckingEnabled = SETTING_DEFAULT_VALUE_FOR_asynchronousSpellCheckingEnabled;
    audioPlaybackRequiresUserGesture = SETTING_DEFAULT_VALUE_FOR_audioPlaybackRequiresUserGesture;
    authorAndUserStylesEnabled = SETTING_DEFAULT_VALUE_FOR_authorAndUserStylesEnabled;
    autoscrollForDragAndDropEnabled = SETTING_DEFAULT_VALUE_FOR_autoscrollForDragAndDropEnabled;
    backgroundShouldExtendBeyondPage = SETTING_DEFAULT_VALUE_FOR_backgroundShouldExtendBeyondPage;
    backspaceKeyNavigationEnabled = SETTING_DEFAULT_VALUE_FOR_backspaceKeyNavigationEnabled;
    beaconAPIEnabled = SETTING_DEFAULT_VALUE_FOR_beaconAPIEnabled;
    blankAnchorTargetImpliesNoOpenerEnabled = SETTING_DEFAULT_VALUE_FOR_blankAnchorTargetImpliesNoOpenerEnabled;
    broadcastChannelEnabled = SETTING_DEFAULT_VALUE_FOR_broadcastChannelEnabled;
    broadcastChannelOriginPartitioningEnabled = SETTING_DEFAULT_VALUE_FOR_broadcastChannelOriginPartitioningEnabled;
    canvasColorSpaceEnabled = SETTING_DEFAULT_VALUE_FOR_canvasColorSpaceEnabled;
    canvasUsesAcceleratedDrawing = SETTING_DEFAULT_VALUE_FOR_canvasUsesAcceleratedDrawing;
    caretBrowsingEnabled = SETTING_DEFAULT_VALUE_FOR_caretBrowsingEnabled;
    clientCoordinatesRelativeToLayoutViewport = SETTING_DEFAULT_VALUE_FOR_clientCoordinatesRelativeToLayoutViewport;
    colorFilterEnabled = SETTING_DEFAULT_VALUE_FOR_colorFilterEnabled;
    constantPropertiesEnabled = SETTING_DEFAULT_VALUE_FOR_constantPropertiesEnabled;
    contactPickerAPIEnabled = SETTING_DEFAULT_VALUE_FOR_contactPickerAPIEnabled;
    contentDispositionAttachmentSandboxEnabled = SETTING_DEFAULT_VALUE_FOR_contentDispositionAttachmentSandboxEnabled;
    cookieConsentAPIEnabled = SETTING_DEFAULT_VALUE_FOR_cookieConsentAPIEnabled;
    cookieEnabled = SETTING_DEFAULT_VALUE_FOR_cookieEnabled;
    coreMathMLEnabled = SETTING_DEFAULT_VALUE_FOR_coreMathMLEnabled;
    crossOriginCheckInGetMatchedCSSRulesDisabled = SETTING_DEFAULT_VALUE_FOR_crossOriginCheckInGetMatchedCSSRulesDisabled;
    crossOriginEmbedderPolicyEnabled = SETTING_DEFAULT_VALUE_FOR_crossOriginEmbedderPolicyEnabled;
    crossOriginOpenerPolicyEnabled = SETTING_DEFAULT_VALUE_FOR_crossOriginOpenerPolicyEnabled;
    css3DTransformInteroperabilityEnabled = SETTING_DEFAULT_VALUE_FOR_css3DTransformInteroperabilityEnabled;
    cssCascadeLayersEnabled = SETTING_DEFAULT_VALUE_FOR_cssCascadeLayersEnabled;
    cssColor4 = SETTING_DEFAULT_VALUE_FOR_cssColor4;
    cssColorContrastEnabled = SETTING_DEFAULT_VALUE_FOR_cssColorContrastEnabled;
    cssColorMixEnabled = SETTING_DEFAULT_VALUE_FOR_cssColorMixEnabled;
    cssContainerQueriesEnabled = SETTING_DEFAULT_VALUE_FOR_cssContainerQueriesEnabled;
    cssContainmentEnabled = SETTING_DEFAULT_VALUE_FOR_cssContainmentEnabled;
    cssCounterStyleAtRuleImageSymbolsEnabled = SETTING_DEFAULT_VALUE_FOR_cssCounterStyleAtRuleImageSymbolsEnabled;
    cssCounterStyleAtRulesEnabled = SETTING_DEFAULT_VALUE_FOR_cssCounterStyleAtRulesEnabled;
    cssCustomPropertiesAndValuesEnabled = SETTING_DEFAULT_VALUE_FOR_cssCustomPropertiesAndValuesEnabled;
    cssGradientInterpolationColorSpacesEnabled = SETTING_DEFAULT_VALUE_FOR_cssGradientInterpolationColorSpacesEnabled;
    cssGradientPremultipliedAlphaInterpolationEnabled = SETTING_DEFAULT_VALUE_FOR_cssGradientPremultipliedAlphaInterpolationEnabled;
    cssIndividualTransformPropertiesEnabled = SETTING_DEFAULT_VALUE_FOR_cssIndividualTransformPropertiesEnabled;
    cssInputSecurityEnabled = SETTING_DEFAULT_VALUE_FOR_cssInputSecurityEnabled;
    cssMotionPathEnabled = SETTING_DEFAULT_VALUE_FOR_cssMotionPathEnabled;
    cssRelativeColorSyntaxEnabled = SETTING_DEFAULT_VALUE_FOR_cssRelativeColorSyntaxEnabled;
    dataTransferItemsEnabled = SETTING_DEFAULT_VALUE_FOR_dataTransferItemsEnabled;
    deferredCSSParserEnabled = SETTING_DEFAULT_VALUE_FOR_deferredCSSParserEnabled;
    developerExtrasEnabled = SETTING_DEFAULT_VALUE_FOR_developerExtrasEnabled;
    diagnosticLoggingEnabled = SETTING_DEFAULT_VALUE_FOR_diagnosticLoggingEnabled;
    dialogElementEnabled = SETTING_DEFAULT_VALUE_FOR_dialogElementEnabled;
    disableScreenSizeOverride = SETTING_DEFAULT_VALUE_FOR_disableScreenSizeOverride;
    disabledAdaptationsMetaTagEnabled = SETTING_DEFAULT_VALUE_FOR_disabledAdaptationsMetaTagEnabled;
    disallowSyncXHRDuringPageDismissalEnabled = SETTING_DEFAULT_VALUE_FOR_disallowSyncXHRDuringPageDismissalEnabled;
    displayListDrawingEnabled = SETTING_DEFAULT_VALUE_FOR_displayListDrawingEnabled;
    dnsPrefetchingEnabled = SETTING_DEFAULT_VALUE_FOR_dnsPrefetchingEnabled;
    domPasteAccessRequestsEnabled = SETTING_DEFAULT_VALUE_FOR_domPasteAccessRequestsEnabled;
    domPasteAllowed = SETTING_DEFAULT_VALUE_FOR_domPasteAllowed;
    domTimersThrottlingEnabled = SETTING_DEFAULT_VALUE_FOR_domTimersThrottlingEnabled;
    downloadableBinaryFontsEnabled = SETTING_DEFAULT_VALUE_FOR_downloadableBinaryFontsEnabled;
    enableInheritURIQueryComponent = SETTING_DEFAULT_VALUE_FOR_enableInheritURIQueryComponent;
    enterKeyHintEnabled = SETTING_DEFAULT_VALUE_FOR_enterKeyHintEnabled;
    eventHandlerDrivenSmoothKeyboardScrollingEnabled = SETTING_DEFAULT_VALUE_FOR_eventHandlerDrivenSmoothKeyboardScrollingEnabled;
    fileSystemAccessEnabled = SETTING_DEFAULT_VALUE_FOR_fileSystemAccessEnabled;
    fixedBackgroundsPaintRelativeToDocument = SETTING_DEFAULT_VALUE_FOR_fixedBackgroundsPaintRelativeToDocument;
    fixedElementsLayoutRelativeToFrame = SETTING_DEFAULT_VALUE_FOR_fixedElementsLayoutRelativeToFrame;
    focusVisibleEnabled = SETTING_DEFAULT_VALUE_FOR_focusVisibleEnabled;
    fontFallbackPrefersPictographs = SETTING_DEFAULT_VALUE_FOR_fontFallbackPrefersPictographs;
    forceCompositingMode = SETTING_DEFAULT_VALUE_FOR_forceCompositingMode;
    forceFTPDirectoryListings = SETTING_DEFAULT_VALUE_FOR_forceFTPDirectoryListings;
    forcePendingWebGLPolicy = SETTING_DEFAULT_VALUE_FOR_forcePendingWebGLPolicy;
    forceWebGLUsesLowPower = SETTING_DEFAULT_VALUE_FOR_forceWebGLUsesLowPower;
    ftpEnabled = SETTING_DEFAULT_VALUE_FOR_ftpEnabled;
    geolocationFloorLevelEnabled = SETTING_DEFAULT_VALUE_FOR_geolocationFloorLevelEnabled;
    googleAntiFlickerOptimizationQuirkEnabled = SETTING_DEFAULT_VALUE_FOR_googleAntiFlickerOptimizationQuirkEnabled;
    hasPseudoClassEnabled = SETTING_DEFAULT_VALUE_FOR_hasPseudoClassEnabled;
    hdrMediaCapabilitiesEnabled = SETTING_DEFAULT_VALUE_FOR_hdrMediaCapabilitiesEnabled;
    hiddenPageCSSAnimationSuspensionEnabled = SETTING_DEFAULT_VALUE_FOR_hiddenPageCSSAnimationSuspensionEnabled;
    hiddenPageDOMTimerThrottlingAutoIncreases = SETTING_DEFAULT_VALUE_FOR_hiddenPageDOMTimerThrottlingAutoIncreases;
    hiddenPageDOMTimerThrottlingEnabled = SETTING_DEFAULT_VALUE_FOR_hiddenPageDOMTimerThrottlingEnabled;
    httpEquivEnabled = SETTING_DEFAULT_VALUE_FOR_httpEquivEnabled;
    hyperlinkAuditingEnabled = SETTING_DEFAULT_VALUE_FOR_hyperlinkAuditingEnabled;
    iceCandidateFilteringEnabled = SETTING_DEFAULT_VALUE_FOR_iceCandidateFilteringEnabled;
    imageSubsamplingEnabled = SETTING_DEFAULT_VALUE_FOR_imageSubsamplingEnabled;
    imagesEnabled = SETTING_DEFAULT_VALUE_FOR_imagesEnabled;
    inProcessCookieCacheEnabled = SETTING_DEFAULT_VALUE_FOR_inProcessCookieCacheEnabled;
    incompleteImageBorderEnabled = SETTING_DEFAULT_VALUE_FOR_incompleteImageBorderEnabled;
    inertAttributeEnabled = SETTING_DEFAULT_VALUE_FOR_inertAttributeEnabled;
    inlineMediaPlaybackRequiresPlaysInlineAttribute = SETTING_DEFAULT_VALUE_FOR_inlineMediaPlaybackRequiresPlaysInlineAttribute;
    interactiveFormValidationEnabled = SETTING_DEFAULT_VALUE_FOR_interactiveFormValidationEnabled;
    intersectionObserverEnabled = SETTING_DEFAULT_VALUE_FOR_intersectionObserverEnabled;
    invisibleAutoplayNotPermitted = SETTING_DEFAULT_VALUE_FOR_invisibleAutoplayNotPermitted;
    isAccessibilityIsolatedTreeEnabled = SETTING_DEFAULT_VALUE_FOR_isAccessibilityIsolatedTreeEnabled;
    isFirstPartyWebsiteDataRemovalDisabled = SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalDisabled;
    isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled = SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled;
    isFirstPartyWebsiteDataRemovalReproTestingEnabled = SETTING_DEFAULT_VALUE_FOR_isFirstPartyWebsiteDataRemovalReproTestingEnabled;
    isLoggedInAPIEnabled = SETTING_DEFAULT_VALUE_FOR_isLoggedInAPIEnabled;
    isPerActivityStateCPUUsageMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_isPerActivityStateCPUUsageMeasurementEnabled;
    isPostBackgroundingCPUUsageMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingCPUUsageMeasurementEnabled;
    isPostBackgroundingMemoryUsageMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_isPostBackgroundingMemoryUsageMeasurementEnabled;
    isPostLoadCPUUsageMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_isPostLoadCPUUsageMeasurementEnabled;
    isPostLoadMemoryUsageMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_isPostLoadMemoryUsageMeasurementEnabled;
    isSameSiteStrictEnforcementEnabled = SETTING_DEFAULT_VALUE_FOR_isSameSiteStrictEnforcementEnabled;
    isThirdPartyCookieBlockingDisabled = SETTING_DEFAULT_VALUE_FOR_isThirdPartyCookieBlockingDisabled;
    javaEnabled = SETTING_DEFAULT_VALUE_FOR_javaEnabled;
    javaEnabledForLocalFiles = SETTING_DEFAULT_VALUE_FOR_javaEnabledForLocalFiles;
    javaScriptCanAccessClipboard = SETTING_DEFAULT_VALUE_FOR_javaScriptCanAccessClipboard;
    javaScriptCanOpenWindowsAutomatically = SETTING_DEFAULT_VALUE_FOR_javaScriptCanOpenWindowsAutomatically;
    langAttributeAwareFormControlUIEnabled = SETTING_DEFAULT_VALUE_FOR_langAttributeAwareFormControlUIEnabled;
    largeImageAsyncDecodingEnabled = SETTING_DEFAULT_VALUE_FOR_largeImageAsyncDecodingEnabled;
    lazyIframeLoadingEnabled = SETTING_DEFAULT_VALUE_FOR_lazyIframeLoadingEnabled;
    lazyImageLoadingEnabled = SETTING_DEFAULT_VALUE_FOR_lazyImageLoadingEnabled;
    legacyLineLayoutVisualCoverageEnabled = SETTING_DEFAULT_VALUE_FOR_legacyLineLayoutVisualCoverageEnabled;
    linkPreconnectEnabled = SETTING_DEFAULT_VALUE_FOR_linkPreconnectEnabled;
    linkPrefetchEnabled = SETTING_DEFAULT_VALUE_FOR_linkPrefetchEnabled;
    linkPreloadEnabled = SETTING_DEFAULT_VALUE_FOR_linkPreloadEnabled;
    linkPreloadResponsiveImagesEnabled = SETTING_DEFAULT_VALUE_FOR_linkPreloadResponsiveImagesEnabled;
    linkSanitizerEnabled = SETTING_DEFAULT_VALUE_FOR_linkSanitizerEnabled;
    liveRangeSelectionEnabled = SETTING_DEFAULT_VALUE_FOR_liveRangeSelectionEnabled;
    loadDeferringEnabled = SETTING_DEFAULT_VALUE_FOR_loadDeferringEnabled;
    loadsImagesAutomatically = SETTING_DEFAULT_VALUE_FOR_loadsImagesAutomatically;
    loadsSiteIconsIgnoringImageLoadingSetting = SETTING_DEFAULT_VALUE_FOR_loadsSiteIconsIgnoringImageLoadingSetting;
    localFileContentSniffingEnabled = SETTING_DEFAULT_VALUE_FOR_localFileContentSniffingEnabled;
    localStorageEnabled = SETTING_DEFAULT_VALUE_FOR_localStorageEnabled;
    logsPageMessagesToSystemConsoleEnabled = SETTING_DEFAULT_VALUE_FOR_logsPageMessagesToSystemConsoleEnabled;
    mainContentUserGestureOverrideEnabled = SETTING_DEFAULT_VALUE_FOR_mainContentUserGestureOverrideEnabled;
    mediaCapabilitiesEnabled = SETTING_DEFAULT_VALUE_FOR_mediaCapabilitiesEnabled;
    mediaCapabilitiesExtensionsEnabled = SETTING_DEFAULT_VALUE_FOR_mediaCapabilitiesExtensionsEnabled;
    mediaControlsScaleWithPageZoom = SETTING_DEFAULT_VALUE_FOR_mediaControlsScaleWithPageZoom;
    mediaDataLoadsAutomatically = SETTING_DEFAULT_VALUE_FOR_mediaDataLoadsAutomatically;
    mediaPreloadingEnabled = SETTING_DEFAULT_VALUE_FOR_mediaPreloadingEnabled;
    mediaSourceEnabled = SETTING_DEFAULT_VALUE_FOR_mediaSourceEnabled;
    mediaUserGestureInheritsFromDocument = SETTING_DEFAULT_VALUE_FOR_mediaUserGestureInheritsFromDocument;
    mockScrollbarsControllerEnabled = SETTING_DEFAULT_VALUE_FOR_mockScrollbarsControllerEnabled;
    momentumScrollingAnimatorEnabled = SETTING_DEFAULT_VALUE_FOR_momentumScrollingAnimatorEnabled;
    needsAdobeFrameReloadingQuirk = SETTING_DEFAULT_VALUE_FOR_needsAdobeFrameReloadingQuirk;
    needsDeferKeyDownAndKeyPressTimersUntilNextEditingCommandQuirk = SETTING_DEFAULT_VALUE_FOR_needsDeferKeyDownAndKeyPressTimersUntilNextEditingCommandQuirk;
    needsFrameNameFallbackToIdQuirk = SETTING_DEFAULT_VALUE_FOR_needsFrameNameFallbackToIdQuirk;
    needsKeyboardEventDisambiguationQuirks = SETTING_DEFAULT_VALUE_FOR_needsKeyboardEventDisambiguationQuirks;
    needsSiteSpecificQuirks = SETTING_DEFAULT_VALUE_FOR_needsSiteSpecificQuirks;
    needsStorageAccessFromFileURLsQuirk = SETTING_DEFAULT_VALUE_FOR_needsStorageAccessFromFileURLsQuirk;
    offlineWebApplicationCacheEnabled = SETTING_DEFAULT_VALUE_FOR_offlineWebApplicationCacheEnabled;
    overflowClipEnabled = SETTING_DEFAULT_VALUE_FOR_overflowClipEnabled;
    overscrollBehaviorEnabled = SETTING_DEFAULT_VALUE_FOR_overscrollBehaviorEnabled;
    paginateDuringLayoutEnabled = SETTING_DEFAULT_VALUE_FOR_paginateDuringLayoutEnabled;
    passiveTouchListenersAsDefaultOnDocument = SETTING_DEFAULT_VALUE_FOR_passiveTouchListenersAsDefaultOnDocument;
    passiveWheelListenersAsDefaultOnDocument = SETTING_DEFAULT_VALUE_FOR_passiveWheelListenersAsDefaultOnDocument;
    passwordEchoEnabled = SETTING_DEFAULT_VALUE_FOR_passwordEchoEnabled;
    pdfJSViewerEnabled = SETTING_DEFAULT_VALUE_FOR_pdfJSViewerEnabled;
    performanceNavigationTimingAPIEnabled = SETTING_DEFAULT_VALUE_FOR_performanceNavigationTimingAPIEnabled;
    performanceResourceTimingSensitivePropertiesEnabled = SETTING_DEFAULT_VALUE_FOR_performanceResourceTimingSensitivePropertiesEnabled;
    permissionsAPIEnabled = SETTING_DEFAULT_VALUE_FOR_permissionsAPIEnabled;
    pluginsEnabled = SETTING_DEFAULT_VALUE_FOR_pluginsEnabled;
    preferMIMETypeForImages = SETTING_DEFAULT_VALUE_FOR_preferMIMETypeForImages;
    preferPageRenderingUpdatesNear60FPSEnabled = SETTING_DEFAULT_VALUE_FOR_preferPageRenderingUpdatesNear60FPSEnabled;
    preventKeyboardDOMEventDispatch = SETTING_DEFAULT_VALUE_FOR_preventKeyboardDOMEventDispatch;
    privateClickMeasurementEnabled = SETTING_DEFAULT_VALUE_FOR_privateClickMeasurementEnabled;
    privateClickMeasurementFraudPreventionEnabled = SETTING_DEFAULT_VALUE_FOR_privateClickMeasurementFraudPreventionEnabled;
    punchOutWhiteBackgroundsInDarkMode = SETTING_DEFAULT_VALUE_FOR_punchOutWhiteBackgroundsInDarkMode;
    referrerPolicyAttributeEnabled = SETTING_DEFAULT_VALUE_FOR_referrerPolicyAttributeEnabled;
    repaintOutsideLayoutEnabled = SETTING_DEFAULT_VALUE_FOR_repaintOutsideLayoutEnabled;
    requestIdleCallbackEnabled = SETTING_DEFAULT_VALUE_FOR_requestIdleCallbackEnabled;
    requestSubmitEnabled = SETTING_DEFAULT_VALUE_FOR_requestSubmitEnabled;
    requestVideoFrameCallbackEnabled = SETTING_DEFAULT_VALUE_FOR_requestVideoFrameCallbackEnabled;
    requiresPageVisibilityToPlayAudio = SETTING_DEFAULT_VALUE_FOR_requiresPageVisibilityToPlayAudio;
    requiresUserGestureToLoadVideo = SETTING_DEFAULT_VALUE_FOR_requiresUserGestureToLoadVideo;
    resizeObserverEnabled = SETTING_DEFAULT_VALUE_FOR_resizeObserverEnabled;
    resolutionMediaFeatureEnabled = SETTING_DEFAULT_VALUE_FOR_resolutionMediaFeatureEnabled;
    resourceLoadSchedulingEnabled = SETTING_DEFAULT_VALUE_FOR_resourceLoadSchedulingEnabled;
    scriptEnabled = SETTING_DEFAULT_VALUE_FOR_scriptEnabled;
    scriptMarkupEnabled = SETTING_DEFAULT_VALUE_FOR_scriptMarkupEnabled;
    scrollAnimatorEnabled = SETTING_DEFAULT_VALUE_FOR_scrollAnimatorEnabled;
    scrollToTextFragmentEnabled = SETTING_DEFAULT_VALUE_FOR_scrollToTextFragmentEnabled;
    scrollingCoordinatorEnabled = SETTING_DEFAULT_VALUE_FOR_scrollingCoordinatorEnabled;
    scrollingPerformanceTestingEnabled = SETTING_DEFAULT_VALUE_FOR_scrollingPerformanceTestingEnabled;
    scrollingTreeIncludesFrames = SETTING_DEFAULT_VALUE_FOR_scrollingTreeIncludesFrames;
    selectTrailingWhitespaceEnabled = SETTING_DEFAULT_VALUE_FOR_selectTrailingWhitespaceEnabled;
    selectionPaintingWithoutSelectionGapsEnabled = SETTING_DEFAULT_VALUE_FOR_selectionPaintingWithoutSelectionGapsEnabled;
    sharedWorkerEnabled = SETTING_DEFAULT_VALUE_FOR_sharedWorkerEnabled;
    shouldAllowUserInstalledFonts = SETTING_DEFAULT_VALUE_FOR_shouldAllowUserInstalledFonts;
    shouldConvertInvalidURLsToBlank = SETTING_DEFAULT_VALUE_FOR_shouldConvertInvalidURLsToBlank;
    shouldConvertPositionStyleOnCopy = SETTING_DEFAULT_VALUE_FOR_shouldConvertPositionStyleOnCopy;
    shouldDecidePolicyBeforeLoadingQuickLookPreview = SETTING_DEFAULT_VALUE_FOR_shouldDecidePolicyBeforeLoadingQuickLookPreview;
    shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint = SETTING_DEFAULT_VALUE_FOR_shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint;
    shouldDispatchSyntheticMouseEventsWhenModifyingSelection = SETTING_DEFAULT_VALUE_FOR_shouldDispatchSyntheticMouseEventsWhenModifyingSelection;
    shouldDispatchSyntheticMouseOutAfterSyntheticClick = SETTING_DEFAULT_VALUE_FOR_shouldDispatchSyntheticMouseOutAfterSyntheticClick;
    shouldIgnoreFontLoadCompletions = SETTING_DEFAULT_VALUE_FOR_shouldIgnoreFontLoadCompletions;
    shouldIgnoreMetaViewport = SETTING_DEFAULT_VALUE_FOR_shouldIgnoreMetaViewport;
    shouldInjectUserScriptsInInitialEmptyDocument = SETTING_DEFAULT_VALUE_FOR_shouldInjectUserScriptsInInitialEmptyDocument;
    shouldPrintBackgrounds = SETTING_DEFAULT_VALUE_FOR_shouldPrintBackgrounds;
    shouldRespectImageOrientation = SETTING_DEFAULT_VALUE_FOR_shouldRespectImageOrientation;
    shouldRestrictBaseURLSchemes = SETTING_DEFAULT_VALUE_FOR_shouldRestrictBaseURLSchemes;
    shouldSuppressTextInputFromEditingDuringProvisionalNavigation = SETTING_DEFAULT_VALUE_FOR_shouldSuppressTextInputFromEditingDuringProvisionalNavigation;
    shouldUseServiceWorkerShortTimeout = SETTING_DEFAULT_VALUE_FOR_shouldUseServiceWorkerShortTimeout;
    showDebugBorders = SETTING_DEFAULT_VALUE_FOR_showDebugBorders;
    showRepaintCounter = SETTING_DEFAULT_VALUE_FOR_showRepaintCounter;
    showTiledScrollingIndicator = SETTING_DEFAULT_VALUE_FOR_showTiledScrollingIndicator;
    showsToolTipOverTruncatedText = SETTING_DEFAULT_VALUE_FOR_showsToolTipOverTruncatedText;
    showsURLsInToolTips = SETTING_DEFAULT_VALUE_FOR_showsURLsInToolTips;
    shrinksStandaloneImagesToFit = SETTING_DEFAULT_VALUE_FOR_shrinksStandaloneImagesToFit;
    simpleLineLayoutEnabled = SETTING_DEFAULT_VALUE_FOR_simpleLineLayoutEnabled;
    smartInsertDeleteEnabled = SETTING_DEFAULT_VALUE_FOR_smartInsertDeleteEnabled;
    spatialNavigationEnabled = SETTING_DEFAULT_VALUE_FOR_spatialNavigationEnabled;
    speechRecognitionEnabled = SETTING_DEFAULT_VALUE_FOR_speechRecognitionEnabled;
    springTimingFunctionEnabled = SETTING_DEFAULT_VALUE_FOR_springTimingFunctionEnabled;
    standalone = SETTING_DEFAULT_VALUE_FOR_standalone;
    storageAPIEnabled = SETTING_DEFAULT_VALUE_FOR_storageAPIEnabled;
    storageAccessAPIEnabled = SETTING_DEFAULT_VALUE_FOR_storageAccessAPIEnabled;
    storageAccessAPIPerPageScopeEnabled = SETTING_DEFAULT_VALUE_FOR_storageAccessAPIPerPageScopeEnabled;
    subgridEnabled = SETTING_DEFAULT_VALUE_FOR_subgridEnabled;
    subpixelAntialiasedLayerTextEnabled = SETTING_DEFAULT_VALUE_FOR_subpixelAntialiasedLayerTextEnabled;
    suppressesIncrementalRendering = SETTING_DEFAULT_VALUE_FOR_suppressesIncrementalRendering;
    syntheticEditingCommandsEnabled = SETTING_DEFAULT_VALUE_FOR_syntheticEditingCommandsEnabled;
    telephoneNumberParsingEnabled = SETTING_DEFAULT_VALUE_FOR_telephoneNumberParsingEnabled;
    temporaryTileCohortRetentionEnabled = SETTING_DEFAULT_VALUE_FOR_temporaryTileCohortRetentionEnabled;
    textAreasAreResizable = SETTING_DEFAULT_VALUE_FOR_textAreasAreResizable;
    textInteractionEnabled = SETTING_DEFAULT_VALUE_FOR_textInteractionEnabled;
    thirdPartyIframeRedirectBlockingEnabled = SETTING_DEFAULT_VALUE_FOR_thirdPartyIframeRedirectBlockingEnabled;
    trackConfigurationEnabled = SETTING_DEFAULT_VALUE_FOR_trackConfigurationEnabled;
    transformStreamAPIEnabled = SETTING_DEFAULT_VALUE_FOR_transformStreamAPIEnabled;
    treatIPAddressAsDomain = SETTING_DEFAULT_VALUE_FOR_treatIPAddressAsDomain;
    treatsAnyTextCSSLinkAsStylesheet = SETTING_DEFAULT_VALUE_FOR_treatsAnyTextCSSLinkAsStylesheet;
    undoManagerAPIEnabled = SETTING_DEFAULT_VALUE_FOR_undoManagerAPIEnabled;
    unhandledPromiseRejectionToConsoleEnabled = SETTING_DEFAULT_VALUE_FOR_unhandledPromiseRejectionToConsoleEnabled;
    unifiedTextCheckerEnabled = SETTING_DEFAULT_VALUE_FOR_unifiedTextCheckerEnabled;
    useAnonymousModeWhenFetchingMaskImages = SETTING_DEFAULT_VALUE_FOR_useAnonymousModeWhenFetchingMaskImages;
    useGiantTiles = SETTING_DEFAULT_VALUE_FOR_useGiantTiles;
    useImageDocumentForSubframePDF = SETTING_DEFAULT_VALUE_FOR_useImageDocumentForSubframePDF;
    useLegacyBackgroundSizeShorthandBehavior = SETTING_DEFAULT_VALUE_FOR_useLegacyBackgroundSizeShorthandBehavior;
    useLegacyTextAlignPositionedElementBehavior = SETTING_DEFAULT_VALUE_FOR_useLegacyTextAlignPositionedElementBehavior;
    usePreHTML5ParserQuirks = SETTING_DEFAULT_VALUE_FOR_usePreHTML5ParserQuirks;
    usesBackForwardCache = SETTING_DEFAULT_VALUE_FOR_usesBackForwardCache;
    usesEncodingDetector = SETTING_DEFAULT_VALUE_FOR_usesEncodingDetector;
    videoPlaybackRequiresUserGesture = SETTING_DEFAULT_VALUE_FOR_videoPlaybackRequiresUserGesture;
    viewportFitEnabled = SETTING_DEFAULT_VALUE_FOR_viewportFitEnabled;
    visualViewportAPIEnabled = SETTING_DEFAULT_VALUE_FOR_visualViewportAPIEnabled;
    visualViewportEnabled = SETTING_DEFAULT_VALUE_FOR_visualViewportEnabled;
    wantsBalancedSetDefersLoadingBehavior = SETTING_DEFAULT_VALUE_FOR_wantsBalancedSetDefersLoadingBehavior;
    webAnimationsCompositeOperationsEnabled = SETTING_DEFAULT_VALUE_FOR_webAnimationsCompositeOperationsEnabled;
    webAnimationsCustomEffectsEnabled = SETTING_DEFAULT_VALUE_FOR_webAnimationsCustomEffectsEnabled;
    webAnimationsCustomFrameRateEnabled = SETTING_DEFAULT_VALUE_FOR_webAnimationsCustomFrameRateEnabled;
    webAnimationsMutableTimelinesEnabled = SETTING_DEFAULT_VALUE_FOR_webAnimationsMutableTimelinesEnabled;
    webGLEnabled = SETTING_DEFAULT_VALUE_FOR_webGLEnabled;
    webGLErrorsToConsoleEnabled = SETTING_DEFAULT_VALUE_FOR_webGLErrorsToConsoleEnabled;
    webGPU = SETTING_DEFAULT_VALUE_FOR_webGPU;
    webKitAdditionsFeature1Enabled = SETTING_DEFAULT_VALUE_FOR_webKitAdditionsFeature1Enabled;
    webLocksAPIEnabled = SETTING_DEFAULT_VALUE_FOR_webLocksAPIEnabled;
    webRTCEncryptionEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCEncryptionEnabled;
    webSecurityEnabled = SETTING_DEFAULT_VALUE_FOR_webSecurityEnabled;
    webShareEnabled = SETTING_DEFAULT_VALUE_FOR_webShareEnabled;
    webShareFileAPIEnabled = SETTING_DEFAULT_VALUE_FOR_webShareFileAPIEnabled;
    webkitImageReadyEventEnabled = SETTING_DEFAULT_VALUE_FOR_webkitImageReadyEventEnabled;
    wheelEventGesturesBecomeNonBlocking = SETTING_DEFAULT_VALUE_FOR_wheelEventGesturesBecomeNonBlocking;
    windowFocusRestricted = SETTING_DEFAULT_VALUE_FOR_windowFocusRestricted;
    xssAuditorEnabled = SETTING_DEFAULT_VALUE_FOR_xssAuditorEnabled;
#if ENABLE(APPLE_PAY)
    applePayCapabilityDisclosureAllowed = SETTING_DEFAULT_VALUE_FOR_applePayCapabilityDisclosureAllowed;
    applePayEnabled = SETTING_DEFAULT_VALUE_FOR_applePayEnabled;
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
    applePayRemoteUIEnabled = SETTING_DEFAULT_VALUE_FOR_applePayRemoteUIEnabled;
#endif
#if ENABLE(APP_HIGHLIGHTS)
    appHighlightsEnabled = SETTING_DEFAULT_VALUE_FOR_appHighlightsEnabled;
#endif
#if ENABLE(CONTENT_CHANGE_OBSERVER)
    contentChangeObserverEnabled = SETTING_DEFAULT_VALUE_FOR_contentChangeObserverEnabled;
#endif
#if ENABLE(CSS_TRANSFORM_STYLE_OPTIMIZED_3D)
    cssTransformStyleOptimized3DEnabled = SETTING_DEFAULT_VALUE_FOR_cssTransformStyleOptimized3DEnabled;
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
    dateTimeInputsEditableComponentsEnabled = SETTING_DEFAULT_VALUE_FOR_dateTimeInputsEditableComponentsEnabled;
#endif
#if ENABLE(DEVICE_ORIENTATION)
    deviceOrientationEventEnabled = SETTING_DEFAULT_VALUE_FOR_deviceOrientationEventEnabled;
    deviceOrientationPermissionAPIEnabled = SETTING_DEFAULT_VALUE_FOR_deviceOrientationPermissionAPIEnabled;
#endif
#if ENABLE(DOWNLOAD_ATTRIBUTE)
    downloadAttributeEnabled = SETTING_DEFAULT_VALUE_FOR_downloadAttributeEnabled;
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    encryptedMediaAPIEnabled = SETTING_DEFAULT_VALUE_FOR_encryptedMediaAPIEnabled;
#endif
#if ENABLE(FULLSCREEN_API)
    fullScreenEnabled = SETTING_DEFAULT_VALUE_FOR_fullScreenEnabled;
#endif
#if ENABLE(GAMEPAD)
    gamepadsEnabled = SETTING_DEFAULT_VALUE_FOR_gamepadsEnabled;
#endif
#if ENABLE(IMAGE_ANALYSIS)
    imageAnalysisMarkupEnabled = SETTING_DEFAULT_VALUE_FOR_imageAnalysisMarkupEnabled;
    imageAnalysisQueueEnabled = SETTING_DEFAULT_VALUE_FOR_imageAnalysisQueueEnabled;
    preferInlineTextSelectionInImages = SETTING_DEFAULT_VALUE_FOR_preferInlineTextSelectionInImages;
    textRecognitionEnhancementsEnabled = SETTING_DEFAULT_VALUE_FOR_textRecognitionEnhancementsEnabled;
#endif
#if ENABLE(INPUT_TYPE_COLOR)
    inputTypeColorEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeColorEnabled;
#endif
#if ENABLE(INPUT_TYPE_DATE)
    inputTypeDateEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeDateEnabled;
#endif
#if ENABLE(INPUT_TYPE_DATETIMELOCAL)
    inputTypeDateTimeLocalEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeDateTimeLocalEnabled;
#endif
#if ENABLE(INPUT_TYPE_MONTH)
    inputTypeMonthEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeMonthEnabled;
#endif
#if ENABLE(INPUT_TYPE_TIME)
    inputTypeTimeEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeTimeEnabled;
#endif
#if ENABLE(INPUT_TYPE_WEEK)
    inputTypeWeekEnabled = SETTING_DEFAULT_VALUE_FOR_inputTypeWeekEnabled;
#endif
#if ENABLE(IOS_FORM_CONTROL_REFRESH)
    iOSFormControlRefreshEnabled = SETTING_DEFAULT_VALUE_FOR_iOSFormControlRefreshEnabled;
#endif
#if ENABLE(LAYER_BASED_SVG_ENGINE)
    layerBasedSVGEngineEnabled = SETTING_DEFAULT_VALUE_FOR_layerBasedSVGEngineEnabled;
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    legacyEncryptedMediaAPIEnabled = SETTING_DEFAULT_VALUE_FOR_legacyEncryptedMediaAPIEnabled;
#endif
#if ENABLE(MATHML)
    mathMLEnabled = SETTING_DEFAULT_VALUE_FOR_mathMLEnabled;
#endif
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
    mediaControlsContextMenusEnabled = SETTING_DEFAULT_VALUE_FOR_mediaControlsContextMenusEnabled;
#endif
#if ENABLE(MEDIA_RECORDER)
    mediaRecorderEnabled = SETTING_DEFAULT_VALUE_FOR_mediaRecorderEnabled;
#endif
#if ENABLE(MEDIA_SESSION)
    mediaSessionEnabled = SETTING_DEFAULT_VALUE_FOR_mediaSessionEnabled;
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR)
    mediaSessionCoordinatorEnabled = SETTING_DEFAULT_VALUE_FOR_mediaSessionCoordinatorEnabled;
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR) && ENABLE(MEDIA_SESSION_PLAYLIST)
    mediaSessionPlaylistEnabled = SETTING_DEFAULT_VALUE_FOR_mediaSessionPlaylistEnabled;
#endif
#if ENABLE(MEDIA_SOURCE)
    sourceBufferChangeTypeEnabled = SETTING_DEFAULT_VALUE_FOR_sourceBufferChangeTypeEnabled;
#endif
#if ENABLE(MEDIA_STREAM)
    exposeSpeakersEnabled = SETTING_DEFAULT_VALUE_FOR_exposeSpeakersEnabled;
    getUserMediaRequiresFocus = SETTING_DEFAULT_VALUE_FOR_getUserMediaRequiresFocus;
    interruptAudioOnPageVisibilityChangeEnabled = SETTING_DEFAULT_VALUE_FOR_interruptAudioOnPageVisibilityChangeEnabled;
    mediaCaptureRequiresSecureConnection = SETTING_DEFAULT_VALUE_FOR_mediaCaptureRequiresSecureConnection;
    mediaDevicesEnabled = SETTING_DEFAULT_VALUE_FOR_mediaDevicesEnabled;
    mediaStreamEnabled = SETTING_DEFAULT_VALUE_FOR_mediaStreamEnabled;
    mockCaptureDevicesEnabled = SETTING_DEFAULT_VALUE_FOR_mockCaptureDevicesEnabled;
    perElementSpeakerSelectionEnabled = SETTING_DEFAULT_VALUE_FOR_perElementSpeakerSelectionEnabled;
    screenCaptureEnabled = SETTING_DEFAULT_VALUE_FOR_screenCaptureEnabled;
    speakerSelectionRequiresUserGesture = SETTING_DEFAULT_VALUE_FOR_speakerSelectionRequiresUserGesture;
#endif
#if ENABLE(MODEL_ELEMENT)
    modelElementEnabled = SETTING_DEFAULT_VALUE_FOR_modelElementEnabled;
#endif
#if ENABLE(NOTIFICATIONS)
    notificationsEnabled = SETTING_DEFAULT_VALUE_FOR_notificationsEnabled;
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
    legacyOverflowScrollingTouchEnabled = SETTING_DEFAULT_VALUE_FOR_legacyOverflowScrollingTouchEnabled;
#endif
#if ENABLE(PAYMENT_REQUEST)
    paymentRequestEnabled = SETTING_DEFAULT_VALUE_FOR_paymentRequestEnabled;
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    pictureInPictureAPIEnabled = SETTING_DEFAULT_VALUE_FOR_pictureInPictureAPIEnabled;
#endif
#if ENABLE(RESOURCE_USAGE)
    resourceUsageOverlayVisible = SETTING_DEFAULT_VALUE_FOR_resourceUsageOverlayVisible;
#endif
#if ENABLE(SERVICE_CONTROLS)
    imageControlsEnabled = SETTING_DEFAULT_VALUE_FOR_imageControlsEnabled;
    serviceControlsEnabled = SETTING_DEFAULT_VALUE_FOR_serviceControlsEnabled;
#endif
#if ENABLE(SERVICE_WORKER)
    serviceWorkerNavigationPreloadEnabled = SETTING_DEFAULT_VALUE_FOR_serviceWorkerNavigationPreloadEnabled;
#endif
#if ENABLE(TEXT_AUTOSIZING)
    idempotentModeAutosizingOnlyHonorsPercentages = SETTING_DEFAULT_VALUE_FOR_idempotentModeAutosizingOnlyHonorsPercentages;
    shouldEnableTextAutosizingBoost = SETTING_DEFAULT_VALUE_FOR_shouldEnableTextAutosizingBoost;
    textAutosizingEnabled = SETTING_DEFAULT_VALUE_FOR_textAutosizingEnabled;
    textAutosizingUsesIdempotentMode = SETTING_DEFAULT_VALUE_FOR_textAutosizingUsesIdempotentMode;
#endif
#if ENABLE(TOUCH_EVENTS)
    touchEventEmulationEnabled = SETTING_DEFAULT_VALUE_FOR_touchEventEmulationEnabled;
#endif
#if ENABLE(VIDEO)
    genericCueAPIEnabled = SETTING_DEFAULT_VALUE_FOR_genericCueAPIEnabled;
    mediaEnabled = SETTING_DEFAULT_VALUE_FOR_mediaEnabled;
    shouldDisplayCaptions = SETTING_DEFAULT_VALUE_FOR_shouldDisplayCaptions;
    shouldDisplaySubtitles = SETTING_DEFAULT_VALUE_FOR_shouldDisplaySubtitles;
    shouldDisplayTextDescriptions = SETTING_DEFAULT_VALUE_FOR_shouldDisplayTextDescriptions;
    videoQualityIncludesDisplayCompositingEnabled = SETTING_DEFAULT_VALUE_FOR_videoQualityIncludesDisplayCompositingEnabled;
#endif
#if ENABLE(VP9)
    vp9DecoderEnabled = SETTING_DEFAULT_VALUE_FOR_vp9DecoderEnabled;
#endif
#if ENABLE(WEBGL) && PLATFORM(COCOA)
    webGLUsingMetal = SETTING_DEFAULT_VALUE_FOR_webGLUsingMetal;
#endif
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
    maskWebGLStringsEnabled = SETTING_DEFAULT_VALUE_FOR_maskWebGLStringsEnabled;
#endif
#if ENABLE(WEBGL2)
    webGL2Enabled = SETTING_DEFAULT_VALUE_FOR_webGL2Enabled;
#endif
#if ENABLE(WEBXR)
    webXRAugmentedRealityModuleEnabled = SETTING_DEFAULT_VALUE_FOR_webXRAugmentedRealityModuleEnabled;
    webXREnabled = SETTING_DEFAULT_VALUE_FOR_webXREnabled;
    webXRGamepadsModuleEnabled = SETTING_DEFAULT_VALUE_FOR_webXRGamepadsModuleEnabled;
#endif
#if ENABLE(WEBXR_HANDS)
    webXRHandInputModuleEnabled = SETTING_DEFAULT_VALUE_FOR_webXRHandInputModuleEnabled;
#endif
#if ENABLE(WEB_ARCHIVE)
    webArchiveDebugModeEnabled = SETTING_DEFAULT_VALUE_FOR_webArchiveDebugModeEnabled;
#endif
#if ENABLE(WEB_AUDIO)
    webAudioEnabled = SETTING_DEFAULT_VALUE_FOR_webAudioEnabled;
#endif
#if ENABLE(WEB_AUTHN)
    webAuthenticationEnabled = SETTING_DEFAULT_VALUE_FOR_webAuthenticationEnabled;
#endif
#if ENABLE(WEB_RTC)
    peerConnectionEnabled = SETTING_DEFAULT_VALUE_FOR_peerConnectionEnabled;
    webRTCEncodedTransformEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCEncodedTransformEnabled;
    webRTCH265CodecEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCH265CodecEnabled;
    webRTCPlatformCodecsInGPUProcessEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCPlatformCodecsInGPUProcessEnabled;
    webRTCRemoteVideoFrameEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCRemoteVideoFrameEnabled;
    webRTCSFrameTransformEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCSFrameTransformEnabled;
    webRTCSocketsProxyingEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCSocketsProxyingEnabled;
    webRTCVP9Profile0CodecEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCVP9Profile0CodecEnabled;
    webRTCVP9Profile2CodecEnabled = SETTING_DEFAULT_VALUE_FOR_webRTCVP9Profile2CodecEnabled;
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    allowsAirPlayForMediaPlayback = SETTING_DEFAULT_VALUE_FOR_allowsAirPlayForMediaPlayback;
    remotePlaybackEnabled = SETTING_DEFAULT_VALUE_FOR_remotePlaybackEnabled;
#endif
#if HAVE(RUBBER_BANDING)
    rubberBandingForSubScrollableRegionsEnabled = SETTING_DEFAULT_VALUE_FOR_rubberBandingForSubScrollableRegionsEnabled;
#endif
#if HAVE(SCREEN_CAPTURE_KIT)
    useScreenCaptureKit = SETTING_DEFAULT_VALUE_FOR_useScreenCaptureKit;
#endif
#if PLATFORM(IOS_FAMILY)
    allowViewportShrinkToFitContent = SETTING_DEFAULT_VALUE_FOR_allowViewportShrinkToFitContent;
    alternateFormControlDesignEnabled = SETTING_DEFAULT_VALUE_FOR_alternateFormControlDesignEnabled;
#endif
#if USE(CORE_IMAGE)
    acceleratedFiltersEnabled = SETTING_DEFAULT_VALUE_FOR_acceleratedFiltersEnabled;
#endif
#if USE(SYSTEM_PREVIEW)
    systemPreviewEnabled = SETTING_DEFAULT_VALUE_FOR_systemPreviewEnabled;
#endif
}

Settings::Values Settings::Values::isolatedCopy() const
{
    return {
        crossThreadCopy(authorAndUserStylesEnabledInspectorOverride),
        crossThreadCopy(iceCandidateFilteringEnabledInspectorOverride),
        crossThreadCopy(imagesEnabledInspectorOverride),
        crossThreadCopy(mediaCaptureRequiresSecureConnectionInspectorOverride),
        crossThreadCopy(mockCaptureDevicesEnabledInspectorOverride),
        crossThreadCopy(needsSiteSpecificQuirksInspectorOverride),
        crossThreadCopy(scriptEnabledInspectorOverride),
        crossThreadCopy(showDebugBordersInspectorOverride),
        crossThreadCopy(showRepaintCounterInspectorOverride),
        crossThreadCopy(webRTCEncryptionEnabledInspectorOverride),
        crossThreadCopy(webSecurityEnabledInspectorOverride),
        crossThreadCopy(fontGenericFamilies),
        crossThreadCopy(backForwardCacheExpirationInterval),
        crossThreadCopy(clipboardAccessPolicy),
        crossThreadCopy(defaultFixedFontSize),
        crossThreadCopy(defaultFontSize),
        crossThreadCopy(defaultTextEncodingName),
        crossThreadCopy(defaultVideoPosterURL),
        crossThreadCopy(deviceHeight),
        crossThreadCopy(deviceWidth),
        crossThreadCopy(editableLinkBehavior),
        crossThreadCopy(editingBehaviorType),
        crossThreadCopy(fontLoadTimingOverride),
        crossThreadCopy(fontRenderingMode),
        crossThreadCopy(forcedColorsAreInvertedAccessibilityValue),
        crossThreadCopy(forcedDisplayIsMonochromeAccessibilityValue),
        crossThreadCopy(forcedPrefersContrastAccessibilityValue),
        crossThreadCopy(forcedPrefersReducedMotionAccessibilityValue),
        crossThreadCopy(forcedSupportsHighDynamicRangeValue),
        crossThreadCopy(frameFlattening),
        crossThreadCopy(ftpDirectoryTemplatePath),
        crossThreadCopy(htmlParserScriptingFlagPolicy),
        crossThreadCopy(incrementalRenderingSuppressionTimeoutInSeconds),
        crossThreadCopy(javaScriptRuntimeFlags),
        crossThreadCopy(layoutFallbackWidth),
        crossThreadCopy(layoutViewportHeightExpansionFactor),
        crossThreadCopy(localStorageDatabasePath),
        crossThreadCopy(maxParseDuration),
        crossThreadCopy(maximumAccelerated2dCanvasSize),
        crossThreadCopy(maximumHTMLParserDOMTreeDepth),
        crossThreadCopy(mediaKeysStorageDirectory),
        crossThreadCopy(mediaTypeOverride),
        crossThreadCopy(minimumAccelerated2dCanvasSize),
        crossThreadCopy(minimumFontSize),
        crossThreadCopy(minimumLogicalFontSize),
        crossThreadCopy(passwordEchoDurationInSeconds),
        crossThreadCopy(pdfImageCachingPolicy),
        crossThreadCopy(pitchCorrectionAlgorithm),
        crossThreadCopy(sampledPageTopColorMaxDifference),
        crossThreadCopy(sampledPageTopColorMinHeight),
        crossThreadCopy(sessionStorageQuota),
        crossThreadCopy(storageBlockingPolicy),
        crossThreadCopy(systemLayoutDirection),
        crossThreadCopy(textDirectionSubmenuInclusionBehavior),
        crossThreadCopy(timeWithoutMouseMovementBeforeHidingControls),
        crossThreadCopy(userInterfaceDirectionPolicy),
        crossThreadCopy(userStyleSheetLocation),
        crossThreadCopy(validationMessageTimerMagnification),
        crossThreadCopy(visibleDebugOverlayRegions),
#if ENABLE(DATA_DETECTION)
        crossThreadCopy(dataDetectorTypes),
#endif
#if ENABLE(MEDIA_SOURCE)
        crossThreadCopy(maximumSourceBufferSize),
#endif
#if ENABLE(MEDIA_STREAM)
        crossThreadCopy(mediaDeviceIdentifierStorageDirectory),
#endif
#if ENABLE(TEXT_AUTOSIZING)
        crossThreadCopy(minimumZoomFontSize),
        crossThreadCopy(textAutosizingWindowSizeOverrideHeight),
        crossThreadCopy(textAutosizingWindowSizeOverrideWidth),
#endif
        crossThreadCopy(CSSOMViewScrollingAPIEnabled),
        crossThreadCopy(CSSOMViewSmoothScrollingEnabled),
        crossThreadCopy(acceleratedCompositedAnimationsEnabled),
        crossThreadCopy(acceleratedCompositingEnabled),
        crossThreadCopy(acceleratedCompositingForFixedPositionEnabled),
        crossThreadCopy(acceleratedDrawingEnabled),
        crossThreadCopy(accentColorEnabled),
        crossThreadCopy(accessHandleEnabled),
        crossThreadCopy(aggressiveTileRetentionEnabled),
        crossThreadCopy(allowContentSecurityPolicySourceStarToMatchAnyProtocol),
        crossThreadCopy(allowCrossOriginSubresourcesToAskForCredentials),
        crossThreadCopy(allowDisplayOfInsecureContent),
        crossThreadCopy(allowFileAccessFromFileURLs),
        crossThreadCopy(allowMediaContentTypesRequiringHardwareSupportAsFallback),
        crossThreadCopy(allowMultiElementImplicitSubmission),
        crossThreadCopy(allowRunningOfInsecureContent),
        crossThreadCopy(allowSettingAnyXHRHeaderFromFileURLs),
        crossThreadCopy(allowTopNavigationToDataURLs),
        crossThreadCopy(allowUniversalAccessFromFileURLs),
        crossThreadCopy(allowsInlineMediaPlayback),
        crossThreadCopy(allowsInlineMediaPlaybackAfterFullscreen),
        crossThreadCopy(allowsPictureInPictureMediaPlayback),
        crossThreadCopy(alwaysUseAcceleratedOverflowScroll),
        crossThreadCopy(animatedImageAsyncDecodingEnabled),
        crossThreadCopy(animatedImageDebugCanvasDrawingEnabled),
        crossThreadCopy(appleMailPaginationQuirkEnabled),
        crossThreadCopy(aspectRatioEnabled),
        crossThreadCopy(aspectRatioOfImgFromWidthAndHeightEnabled),
        crossThreadCopy(asyncClipboardAPIEnabled),
        crossThreadCopy(asyncFrameScrollingEnabled),
        crossThreadCopy(asyncOverflowScrollingEnabled),
        crossThreadCopy(asynchronousSpellCheckingEnabled),
        crossThreadCopy(audioPlaybackRequiresUserGesture),
        crossThreadCopy(authorAndUserStylesEnabled),
        crossThreadCopy(autoscrollForDragAndDropEnabled),
        crossThreadCopy(backgroundShouldExtendBeyondPage),
        crossThreadCopy(backspaceKeyNavigationEnabled),
        crossThreadCopy(beaconAPIEnabled),
        crossThreadCopy(blankAnchorTargetImpliesNoOpenerEnabled),
        crossThreadCopy(broadcastChannelEnabled),
        crossThreadCopy(broadcastChannelOriginPartitioningEnabled),
        crossThreadCopy(canvasColorSpaceEnabled),
        crossThreadCopy(canvasUsesAcceleratedDrawing),
        crossThreadCopy(caretBrowsingEnabled),
        crossThreadCopy(clientCoordinatesRelativeToLayoutViewport),
        crossThreadCopy(colorFilterEnabled),
        crossThreadCopy(constantPropertiesEnabled),
        crossThreadCopy(contactPickerAPIEnabled),
        crossThreadCopy(contentDispositionAttachmentSandboxEnabled),
        crossThreadCopy(cookieConsentAPIEnabled),
        crossThreadCopy(cookieEnabled),
        crossThreadCopy(coreMathMLEnabled),
        crossThreadCopy(crossOriginCheckInGetMatchedCSSRulesDisabled),
        crossThreadCopy(crossOriginEmbedderPolicyEnabled),
        crossThreadCopy(crossOriginOpenerPolicyEnabled),
        crossThreadCopy(css3DTransformInteroperabilityEnabled),
        crossThreadCopy(cssCascadeLayersEnabled),
        crossThreadCopy(cssColor4),
        crossThreadCopy(cssColorContrastEnabled),
        crossThreadCopy(cssColorMixEnabled),
        crossThreadCopy(cssContainerQueriesEnabled),
        crossThreadCopy(cssContainmentEnabled),
        crossThreadCopy(cssCounterStyleAtRuleImageSymbolsEnabled),
        crossThreadCopy(cssCounterStyleAtRulesEnabled),
        crossThreadCopy(cssCustomPropertiesAndValuesEnabled),
        crossThreadCopy(cssGradientInterpolationColorSpacesEnabled),
        crossThreadCopy(cssGradientPremultipliedAlphaInterpolationEnabled),
        crossThreadCopy(cssIndividualTransformPropertiesEnabled),
        crossThreadCopy(cssInputSecurityEnabled),
        crossThreadCopy(cssMotionPathEnabled),
        crossThreadCopy(cssRelativeColorSyntaxEnabled),
        crossThreadCopy(dataTransferItemsEnabled),
        crossThreadCopy(deferredCSSParserEnabled),
        crossThreadCopy(developerExtrasEnabled),
        crossThreadCopy(diagnosticLoggingEnabled),
        crossThreadCopy(dialogElementEnabled),
        crossThreadCopy(disableScreenSizeOverride),
        crossThreadCopy(disabledAdaptationsMetaTagEnabled),
        crossThreadCopy(disallowSyncXHRDuringPageDismissalEnabled),
        crossThreadCopy(displayListDrawingEnabled),
        crossThreadCopy(dnsPrefetchingEnabled),
        crossThreadCopy(domPasteAccessRequestsEnabled),
        crossThreadCopy(domPasteAllowed),
        crossThreadCopy(domTimersThrottlingEnabled),
        crossThreadCopy(downloadableBinaryFontsEnabled),
        crossThreadCopy(enableInheritURIQueryComponent),
        crossThreadCopy(enterKeyHintEnabled),
        crossThreadCopy(eventHandlerDrivenSmoothKeyboardScrollingEnabled),
        crossThreadCopy(fileSystemAccessEnabled),
        crossThreadCopy(fixedBackgroundsPaintRelativeToDocument),
        crossThreadCopy(fixedElementsLayoutRelativeToFrame),
        crossThreadCopy(focusVisibleEnabled),
        crossThreadCopy(fontFallbackPrefersPictographs),
        crossThreadCopy(forceCompositingMode),
        crossThreadCopy(forceFTPDirectoryListings),
        crossThreadCopy(forcePendingWebGLPolicy),
        crossThreadCopy(forceWebGLUsesLowPower),
        crossThreadCopy(ftpEnabled),
        crossThreadCopy(geolocationFloorLevelEnabled),
        crossThreadCopy(googleAntiFlickerOptimizationQuirkEnabled),
        crossThreadCopy(hasPseudoClassEnabled),
        crossThreadCopy(hdrMediaCapabilitiesEnabled),
        crossThreadCopy(hiddenPageCSSAnimationSuspensionEnabled),
        crossThreadCopy(hiddenPageDOMTimerThrottlingAutoIncreases),
        crossThreadCopy(hiddenPageDOMTimerThrottlingEnabled),
        crossThreadCopy(httpEquivEnabled),
        crossThreadCopy(hyperlinkAuditingEnabled),
        crossThreadCopy(iceCandidateFilteringEnabled),
        crossThreadCopy(imageSubsamplingEnabled),
        crossThreadCopy(imagesEnabled),
        crossThreadCopy(inProcessCookieCacheEnabled),
        crossThreadCopy(incompleteImageBorderEnabled),
        crossThreadCopy(inertAttributeEnabled),
        crossThreadCopy(inlineMediaPlaybackRequiresPlaysInlineAttribute),
        crossThreadCopy(interactiveFormValidationEnabled),
        crossThreadCopy(intersectionObserverEnabled),
        crossThreadCopy(invisibleAutoplayNotPermitted),
        crossThreadCopy(isAccessibilityIsolatedTreeEnabled),
        crossThreadCopy(isFirstPartyWebsiteDataRemovalDisabled),
        crossThreadCopy(isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled),
        crossThreadCopy(isFirstPartyWebsiteDataRemovalReproTestingEnabled),
        crossThreadCopy(isLoggedInAPIEnabled),
        crossThreadCopy(isPerActivityStateCPUUsageMeasurementEnabled),
        crossThreadCopy(isPostBackgroundingCPUUsageMeasurementEnabled),
        crossThreadCopy(isPostBackgroundingMemoryUsageMeasurementEnabled),
        crossThreadCopy(isPostLoadCPUUsageMeasurementEnabled),
        crossThreadCopy(isPostLoadMemoryUsageMeasurementEnabled),
        crossThreadCopy(isSameSiteStrictEnforcementEnabled),
        crossThreadCopy(isThirdPartyCookieBlockingDisabled),
        crossThreadCopy(javaEnabled),
        crossThreadCopy(javaEnabledForLocalFiles),
        crossThreadCopy(javaScriptCanAccessClipboard),
        crossThreadCopy(javaScriptCanOpenWindowsAutomatically),
        crossThreadCopy(langAttributeAwareFormControlUIEnabled),
        crossThreadCopy(largeImageAsyncDecodingEnabled),
        crossThreadCopy(lazyIframeLoadingEnabled),
        crossThreadCopy(lazyImageLoadingEnabled),
        crossThreadCopy(legacyLineLayoutVisualCoverageEnabled),
        crossThreadCopy(linkPreconnectEnabled),
        crossThreadCopy(linkPrefetchEnabled),
        crossThreadCopy(linkPreloadEnabled),
        crossThreadCopy(linkPreloadResponsiveImagesEnabled),
        crossThreadCopy(linkSanitizerEnabled),
        crossThreadCopy(liveRangeSelectionEnabled),
        crossThreadCopy(loadDeferringEnabled),
        crossThreadCopy(loadsImagesAutomatically),
        crossThreadCopy(loadsSiteIconsIgnoringImageLoadingSetting),
        crossThreadCopy(localFileContentSniffingEnabled),
        crossThreadCopy(localStorageEnabled),
        crossThreadCopy(logsPageMessagesToSystemConsoleEnabled),
        crossThreadCopy(mainContentUserGestureOverrideEnabled),
        crossThreadCopy(mediaCapabilitiesEnabled),
        crossThreadCopy(mediaCapabilitiesExtensionsEnabled),
        crossThreadCopy(mediaControlsScaleWithPageZoom),
        crossThreadCopy(mediaDataLoadsAutomatically),
        crossThreadCopy(mediaPreloadingEnabled),
        crossThreadCopy(mediaSourceEnabled),
        crossThreadCopy(mediaUserGestureInheritsFromDocument),
        crossThreadCopy(mockScrollbarsControllerEnabled),
        crossThreadCopy(momentumScrollingAnimatorEnabled),
        crossThreadCopy(needsAdobeFrameReloadingQuirk),
        crossThreadCopy(needsDeferKeyDownAndKeyPressTimersUntilNextEditingCommandQuirk),
        crossThreadCopy(needsFrameNameFallbackToIdQuirk),
        crossThreadCopy(needsKeyboardEventDisambiguationQuirks),
        crossThreadCopy(needsSiteSpecificQuirks),
        crossThreadCopy(needsStorageAccessFromFileURLsQuirk),
        crossThreadCopy(offlineWebApplicationCacheEnabled),
        crossThreadCopy(overflowClipEnabled),
        crossThreadCopy(overscrollBehaviorEnabled),
        crossThreadCopy(paginateDuringLayoutEnabled),
        crossThreadCopy(passiveTouchListenersAsDefaultOnDocument),
        crossThreadCopy(passiveWheelListenersAsDefaultOnDocument),
        crossThreadCopy(passwordEchoEnabled),
        crossThreadCopy(pdfJSViewerEnabled),
        crossThreadCopy(performanceNavigationTimingAPIEnabled),
        crossThreadCopy(performanceResourceTimingSensitivePropertiesEnabled),
        crossThreadCopy(permissionsAPIEnabled),
        crossThreadCopy(pluginsEnabled),
        crossThreadCopy(preferMIMETypeForImages),
        crossThreadCopy(preferPageRenderingUpdatesNear60FPSEnabled),
        crossThreadCopy(preventKeyboardDOMEventDispatch),
        crossThreadCopy(privateClickMeasurementEnabled),
        crossThreadCopy(privateClickMeasurementFraudPreventionEnabled),
        crossThreadCopy(punchOutWhiteBackgroundsInDarkMode),
        crossThreadCopy(referrerPolicyAttributeEnabled),
        crossThreadCopy(repaintOutsideLayoutEnabled),
        crossThreadCopy(requestIdleCallbackEnabled),
        crossThreadCopy(requestSubmitEnabled),
        crossThreadCopy(requestVideoFrameCallbackEnabled),
        crossThreadCopy(requiresPageVisibilityToPlayAudio),
        crossThreadCopy(requiresUserGestureToLoadVideo),
        crossThreadCopy(resizeObserverEnabled),
        crossThreadCopy(resolutionMediaFeatureEnabled),
        crossThreadCopy(resourceLoadSchedulingEnabled),
        crossThreadCopy(scriptEnabled),
        crossThreadCopy(scriptMarkupEnabled),
        crossThreadCopy(scrollAnimatorEnabled),
        crossThreadCopy(scrollToTextFragmentEnabled),
        crossThreadCopy(scrollingCoordinatorEnabled),
        crossThreadCopy(scrollingPerformanceTestingEnabled),
        crossThreadCopy(scrollingTreeIncludesFrames),
        crossThreadCopy(selectTrailingWhitespaceEnabled),
        crossThreadCopy(selectionPaintingWithoutSelectionGapsEnabled),
        crossThreadCopy(sharedWorkerEnabled),
        crossThreadCopy(shouldAllowUserInstalledFonts),
        crossThreadCopy(shouldConvertInvalidURLsToBlank),
        crossThreadCopy(shouldConvertPositionStyleOnCopy),
        crossThreadCopy(shouldDecidePolicyBeforeLoadingQuickLookPreview),
        crossThreadCopy(shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint),
        crossThreadCopy(shouldDispatchSyntheticMouseEventsWhenModifyingSelection),
        crossThreadCopy(shouldDispatchSyntheticMouseOutAfterSyntheticClick),
        crossThreadCopy(shouldIgnoreFontLoadCompletions),
        crossThreadCopy(shouldIgnoreMetaViewport),
        crossThreadCopy(shouldInjectUserScriptsInInitialEmptyDocument),
        crossThreadCopy(shouldPrintBackgrounds),
        crossThreadCopy(shouldRespectImageOrientation),
        crossThreadCopy(shouldRestrictBaseURLSchemes),
        crossThreadCopy(shouldSuppressTextInputFromEditingDuringProvisionalNavigation),
        crossThreadCopy(shouldUseServiceWorkerShortTimeout),
        crossThreadCopy(showDebugBorders),
        crossThreadCopy(showRepaintCounter),
        crossThreadCopy(showTiledScrollingIndicator),
        crossThreadCopy(showsToolTipOverTruncatedText),
        crossThreadCopy(showsURLsInToolTips),
        crossThreadCopy(shrinksStandaloneImagesToFit),
        crossThreadCopy(simpleLineLayoutEnabled),
        crossThreadCopy(smartInsertDeleteEnabled),
        crossThreadCopy(spatialNavigationEnabled),
        crossThreadCopy(speechRecognitionEnabled),
        crossThreadCopy(springTimingFunctionEnabled),
        crossThreadCopy(standalone),
        crossThreadCopy(storageAPIEnabled),
        crossThreadCopy(storageAccessAPIEnabled),
        crossThreadCopy(storageAccessAPIPerPageScopeEnabled),
        crossThreadCopy(subgridEnabled),
        crossThreadCopy(subpixelAntialiasedLayerTextEnabled),
        crossThreadCopy(suppressesIncrementalRendering),
        crossThreadCopy(syntheticEditingCommandsEnabled),
        crossThreadCopy(telephoneNumberParsingEnabled),
        crossThreadCopy(temporaryTileCohortRetentionEnabled),
        crossThreadCopy(textAreasAreResizable),
        crossThreadCopy(textInteractionEnabled),
        crossThreadCopy(thirdPartyIframeRedirectBlockingEnabled),
        crossThreadCopy(trackConfigurationEnabled),
        crossThreadCopy(transformStreamAPIEnabled),
        crossThreadCopy(treatIPAddressAsDomain),
        crossThreadCopy(treatsAnyTextCSSLinkAsStylesheet),
        crossThreadCopy(undoManagerAPIEnabled),
        crossThreadCopy(unhandledPromiseRejectionToConsoleEnabled),
        crossThreadCopy(unifiedTextCheckerEnabled),
        crossThreadCopy(useAnonymousModeWhenFetchingMaskImages),
        crossThreadCopy(useGiantTiles),
        crossThreadCopy(useImageDocumentForSubframePDF),
        crossThreadCopy(useLegacyBackgroundSizeShorthandBehavior),
        crossThreadCopy(useLegacyTextAlignPositionedElementBehavior),
        crossThreadCopy(usePreHTML5ParserQuirks),
        crossThreadCopy(usesBackForwardCache),
        crossThreadCopy(usesEncodingDetector),
        crossThreadCopy(videoPlaybackRequiresUserGesture),
        crossThreadCopy(viewportFitEnabled),
        crossThreadCopy(visualViewportAPIEnabled),
        crossThreadCopy(visualViewportEnabled),
        crossThreadCopy(wantsBalancedSetDefersLoadingBehavior),
        crossThreadCopy(webAnimationsCompositeOperationsEnabled),
        crossThreadCopy(webAnimationsCustomEffectsEnabled),
        crossThreadCopy(webAnimationsCustomFrameRateEnabled),
        crossThreadCopy(webAnimationsMutableTimelinesEnabled),
        crossThreadCopy(webGLEnabled),
        crossThreadCopy(webGLErrorsToConsoleEnabled),
        crossThreadCopy(webGPU),
        crossThreadCopy(webKitAdditionsFeature1Enabled),
        crossThreadCopy(webLocksAPIEnabled),
        crossThreadCopy(webRTCEncryptionEnabled),
        crossThreadCopy(webSecurityEnabled),
        crossThreadCopy(webShareEnabled),
        crossThreadCopy(webShareFileAPIEnabled),
        crossThreadCopy(webkitImageReadyEventEnabled),
        crossThreadCopy(wheelEventGesturesBecomeNonBlocking),
        crossThreadCopy(windowFocusRestricted),
        crossThreadCopy(xssAuditorEnabled),
#if ENABLE(APPLE_PAY)
        crossThreadCopy(applePayCapabilityDisclosureAllowed),
        crossThreadCopy(applePayEnabled),
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        crossThreadCopy(applePayRemoteUIEnabled),
#endif
#if ENABLE(APP_HIGHLIGHTS)
        crossThreadCopy(appHighlightsEnabled),
#endif
#if ENABLE(CONTENT_CHANGE_OBSERVER)
        crossThreadCopy(contentChangeObserverEnabled),
#endif
#if ENABLE(CSS_TRANSFORM_STYLE_OPTIMIZED_3D)
        crossThreadCopy(cssTransformStyleOptimized3DEnabled),
#endif
#if ENABLE(DATE_AND_TIME_INPUT_TYPES)
        crossThreadCopy(dateTimeInputsEditableComponentsEnabled),
#endif
#if ENABLE(DEVICE_ORIENTATION)
        crossThreadCopy(deviceOrientationEventEnabled),
        crossThreadCopy(deviceOrientationPermissionAPIEnabled),
#endif
#if ENABLE(DOWNLOAD_ATTRIBUTE)
        crossThreadCopy(downloadAttributeEnabled),
#endif
#if ENABLE(ENCRYPTED_MEDIA)
        crossThreadCopy(encryptedMediaAPIEnabled),
#endif
#if ENABLE(FULLSCREEN_API)
        crossThreadCopy(fullScreenEnabled),
#endif
#if ENABLE(GAMEPAD)
        crossThreadCopy(gamepadsEnabled),
#endif
#if ENABLE(IMAGE_ANALYSIS)
        crossThreadCopy(imageAnalysisMarkupEnabled),
        crossThreadCopy(imageAnalysisQueueEnabled),
        crossThreadCopy(preferInlineTextSelectionInImages),
        crossThreadCopy(textRecognitionEnhancementsEnabled),
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        crossThreadCopy(inputTypeColorEnabled),
#endif
#if ENABLE(INPUT_TYPE_DATE)
        crossThreadCopy(inputTypeDateEnabled),
#endif
#if ENABLE(INPUT_TYPE_DATETIMELOCAL)
        crossThreadCopy(inputTypeDateTimeLocalEnabled),
#endif
#if ENABLE(INPUT_TYPE_MONTH)
        crossThreadCopy(inputTypeMonthEnabled),
#endif
#if ENABLE(INPUT_TYPE_TIME)
        crossThreadCopy(inputTypeTimeEnabled),
#endif
#if ENABLE(INPUT_TYPE_WEEK)
        crossThreadCopy(inputTypeWeekEnabled),
#endif
#if ENABLE(IOS_FORM_CONTROL_REFRESH)
        crossThreadCopy(iOSFormControlRefreshEnabled),
#endif
#if ENABLE(LAYER_BASED_SVG_ENGINE)
        crossThreadCopy(layerBasedSVGEngineEnabled),
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
        crossThreadCopy(legacyEncryptedMediaAPIEnabled),
#endif
#if ENABLE(MATHML)
        crossThreadCopy(mathMLEnabled),
#endif
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
        crossThreadCopy(mediaControlsContextMenusEnabled),
#endif
#if ENABLE(MEDIA_RECORDER)
        crossThreadCopy(mediaRecorderEnabled),
#endif
#if ENABLE(MEDIA_SESSION)
        crossThreadCopy(mediaSessionEnabled),
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR)
        crossThreadCopy(mediaSessionCoordinatorEnabled),
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR) && ENABLE(MEDIA_SESSION_PLAYLIST)
        crossThreadCopy(mediaSessionPlaylistEnabled),
#endif
#if ENABLE(MEDIA_SOURCE)
        crossThreadCopy(sourceBufferChangeTypeEnabled),
#endif
#if ENABLE(MEDIA_STREAM)
        crossThreadCopy(exposeSpeakersEnabled),
        crossThreadCopy(getUserMediaRequiresFocus),
        crossThreadCopy(interruptAudioOnPageVisibilityChangeEnabled),
        crossThreadCopy(mediaCaptureRequiresSecureConnection),
        crossThreadCopy(mediaDevicesEnabled),
        crossThreadCopy(mediaStreamEnabled),
        crossThreadCopy(mockCaptureDevicesEnabled),
        crossThreadCopy(perElementSpeakerSelectionEnabled),
        crossThreadCopy(screenCaptureEnabled),
        crossThreadCopy(speakerSelectionRequiresUserGesture),
#endif
#if ENABLE(MODEL_ELEMENT)
        crossThreadCopy(modelElementEnabled),
#endif
#if ENABLE(NOTIFICATIONS)
        crossThreadCopy(notificationsEnabled),
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        crossThreadCopy(legacyOverflowScrollingTouchEnabled),
#endif
#if ENABLE(PAYMENT_REQUEST)
        crossThreadCopy(paymentRequestEnabled),
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
        crossThreadCopy(pictureInPictureAPIEnabled),
#endif
#if ENABLE(RESOURCE_USAGE)
        crossThreadCopy(resourceUsageOverlayVisible),
#endif
#if ENABLE(SERVICE_CONTROLS)
        crossThreadCopy(imageControlsEnabled),
        crossThreadCopy(serviceControlsEnabled),
#endif
#if ENABLE(SERVICE_WORKER)
        crossThreadCopy(serviceWorkerNavigationPreloadEnabled),
#endif
#if ENABLE(TEXT_AUTOSIZING)
        crossThreadCopy(idempotentModeAutosizingOnlyHonorsPercentages),
        crossThreadCopy(shouldEnableTextAutosizingBoost),
        crossThreadCopy(textAutosizingEnabled),
        crossThreadCopy(textAutosizingUsesIdempotentMode),
#endif
#if ENABLE(TOUCH_EVENTS)
        crossThreadCopy(touchEventEmulationEnabled),
#endif
#if ENABLE(VIDEO)
        crossThreadCopy(genericCueAPIEnabled),
        crossThreadCopy(mediaEnabled),
        crossThreadCopy(shouldDisplayCaptions),
        crossThreadCopy(shouldDisplaySubtitles),
        crossThreadCopy(shouldDisplayTextDescriptions),
        crossThreadCopy(videoQualityIncludesDisplayCompositingEnabled),
#endif
#if ENABLE(VP9)
        crossThreadCopy(vp9DecoderEnabled),
#endif
#if ENABLE(WEBGL) && PLATFORM(COCOA)
        crossThreadCopy(webGLUsingMetal),
#endif
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        crossThreadCopy(maskWebGLStringsEnabled),
#endif
#if ENABLE(WEBGL2)
        crossThreadCopy(webGL2Enabled),
#endif
#if ENABLE(WEBXR)
        crossThreadCopy(webXRAugmentedRealityModuleEnabled),
        crossThreadCopy(webXREnabled),
        crossThreadCopy(webXRGamepadsModuleEnabled),
#endif
#if ENABLE(WEBXR_HANDS)
        crossThreadCopy(webXRHandInputModuleEnabled),
#endif
#if ENABLE(WEB_ARCHIVE)
        crossThreadCopy(webArchiveDebugModeEnabled),
#endif
#if ENABLE(WEB_AUDIO)
        crossThreadCopy(webAudioEnabled),
#endif
#if ENABLE(WEB_AUTHN)
        crossThreadCopy(webAuthenticationEnabled),
#endif
#if ENABLE(WEB_RTC)
        crossThreadCopy(peerConnectionEnabled),
        crossThreadCopy(webRTCEncodedTransformEnabled),
        crossThreadCopy(webRTCH265CodecEnabled),
        crossThreadCopy(webRTCPlatformCodecsInGPUProcessEnabled),
        crossThreadCopy(webRTCRemoteVideoFrameEnabled),
        crossThreadCopy(webRTCSFrameTransformEnabled),
        crossThreadCopy(webRTCSocketsProxyingEnabled),
        crossThreadCopy(webRTCVP9Profile0CodecEnabled),
        crossThreadCopy(webRTCVP9Profile2CodecEnabled),
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        crossThreadCopy(allowsAirPlayForMediaPlayback),
        crossThreadCopy(remotePlaybackEnabled),
#endif
#if HAVE(RUBBER_BANDING)
        crossThreadCopy(rubberBandingForSubScrollableRegionsEnabled),
#endif
#if HAVE(SCREEN_CAPTURE_KIT)
        crossThreadCopy(useScreenCaptureKit),
#endif
#if PLATFORM(IOS_FAMILY)
        crossThreadCopy(allowViewportShrinkToFitContent),
        crossThreadCopy(alternateFormControlDesignEnabled),
#endif
#if USE(CORE_IMAGE)
        crossThreadCopy(acceleratedFiltersEnabled),
#endif
#if USE(SYSTEM_PREVIEW)
        crossThreadCopy(systemPreviewEnabled),
#endif
    };
}

Settings::~Settings()
{
}

bool Settings::authorAndUserStylesEnabled() const
{
    if (UNLIKELY(m_values.authorAndUserStylesEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.authorAndUserStylesEnabledInspectorOverride.value();
    }
    return m_values.authorAndUserStylesEnabled;
}
bool Settings::iceCandidateFilteringEnabled() const
{
    if (UNLIKELY(m_values.iceCandidateFilteringEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.iceCandidateFilteringEnabledInspectorOverride.value();
    }
    return m_values.iceCandidateFilteringEnabled;
}
bool Settings::areImagesEnabled() const
{
    if (UNLIKELY(m_values.imagesEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.imagesEnabledInspectorOverride.value();
    }
    return m_values.imagesEnabled;
}
bool Settings::needsSiteSpecificQuirks() const
{
    if (UNLIKELY(m_values.needsSiteSpecificQuirksInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.needsSiteSpecificQuirksInspectorOverride.value();
    }
    return m_values.needsSiteSpecificQuirks;
}
bool Settings::isScriptEnabled() const
{
    if (UNLIKELY(m_values.scriptEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.scriptEnabledInspectorOverride.value();
    }
    return m_values.scriptEnabled;
}
bool Settings::showDebugBorders() const
{
    if (UNLIKELY(m_values.showDebugBordersInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.showDebugBordersInspectorOverride.value();
    }
    return m_values.showDebugBorders;
}
bool Settings::showRepaintCounter() const
{
    if (UNLIKELY(m_values.showRepaintCounterInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.showRepaintCounterInspectorOverride.value();
    }
    return m_values.showRepaintCounter;
}
bool Settings::webRTCEncryptionEnabled() const
{
    if (UNLIKELY(m_values.webRTCEncryptionEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.webRTCEncryptionEnabledInspectorOverride.value();
    }
    return m_values.webRTCEncryptionEnabled;
}
bool Settings::webSecurityEnabled() const
{
    if (UNLIKELY(m_values.webSecurityEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.webSecurityEnabledInspectorOverride.value();
    }
    return m_values.webSecurityEnabled;
}

void Settings::setAcceleratedCompositedAnimationsEnabled(bool acceleratedCompositedAnimationsEnabled)
{
    if (m_values.acceleratedCompositedAnimationsEnabled == acceleratedCompositedAnimationsEnabled)
        return;
    m_values.acceleratedCompositedAnimationsEnabled = acceleratedCompositedAnimationsEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setAcceleratedCompositingEnabled(bool acceleratedCompositingEnabled)
{
    if (m_values.acceleratedCompositingEnabled == acceleratedCompositingEnabled)
        return;
    m_values.acceleratedCompositingEnabled = acceleratedCompositingEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setAsyncFrameScrollingEnabled(bool asyncFrameScrollingEnabled)
{
    if (m_values.asyncFrameScrollingEnabled == asyncFrameScrollingEnabled)
        return;
    m_values.asyncFrameScrollingEnabled = asyncFrameScrollingEnabled;
    setNeedsRelayoutAllFrames();
}
void Settings::setAsyncOverflowScrollingEnabled(bool asyncOverflowScrollingEnabled)
{
    if (m_values.asyncOverflowScrollingEnabled == asyncOverflowScrollingEnabled)
        return;
    m_values.asyncOverflowScrollingEnabled = asyncOverflowScrollingEnabled;
    setNeedsRelayoutAllFrames();
}
void Settings::setAuthorAndUserStylesEnabled(bool authorAndUserStylesEnabled)
{
    if (m_values.authorAndUserStylesEnabled == authorAndUserStylesEnabled)
        return;
    m_values.authorAndUserStylesEnabled = authorAndUserStylesEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setBackgroundShouldExtendBeyondPage(bool backgroundShouldExtendBeyondPage)
{
    if (m_values.backgroundShouldExtendBeyondPage == backgroundShouldExtendBeyondPage)
        return;
    m_values.backgroundShouldExtendBeyondPage = backgroundShouldExtendBeyondPage;
    backgroundShouldExtendBeyondPageChanged();
}
void Settings::setClientCoordinatesRelativeToLayoutViewport(bool clientCoordinatesRelativeToLayoutViewport)
{
    if (m_values.clientCoordinatesRelativeToLayoutViewport == clientCoordinatesRelativeToLayoutViewport)
        return;
    m_values.clientCoordinatesRelativeToLayoutViewport = clientCoordinatesRelativeToLayoutViewport;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setColorFilterEnabled(bool colorFilterEnabled)
{
    if (m_values.colorFilterEnabled == colorFilterEnabled)
        return;
    m_values.colorFilterEnabled = colorFilterEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setCoreMathMLEnabled(bool coreMathMLEnabled)
{
    if (m_values.coreMathMLEnabled == coreMathMLEnabled)
        return;
    m_values.coreMathMLEnabled = coreMathMLEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setDefaultFixedFontSize(double defaultFixedFontSize)
{
    if (m_values.defaultFixedFontSize == defaultFixedFontSize)
        return;
    m_values.defaultFixedFontSize = defaultFixedFontSize;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setDefaultFontSize(double defaultFontSize)
{
    if (m_values.defaultFontSize == defaultFontSize)
        return;
    m_values.defaultFontSize = defaultFontSize;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setDNSPrefetchingEnabled(bool dnsPrefetchingEnabled)
{
    if (m_values.dnsPrefetchingEnabled == dnsPrefetchingEnabled)
        return;
    m_values.dnsPrefetchingEnabled = dnsPrefetchingEnabled;
    dnsPrefetchingEnabledChanged();
}
void Settings::setFontFallbackPrefersPictographs(bool fontFallbackPrefersPictographs)
{
    if (m_values.fontFallbackPrefersPictographs == fontFallbackPrefersPictographs)
        return;
    m_values.fontFallbackPrefersPictographs = fontFallbackPrefersPictographs;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setForcedSupportsHighDynamicRangeValue(ForcedAccessibilityValue forcedSupportsHighDynamicRangeValue)
{
    if (m_values.forcedSupportsHighDynamicRangeValue == forcedSupportsHighDynamicRangeValue)
        return;
    m_values.forcedSupportsHighDynamicRangeValue = forcedSupportsHighDynamicRangeValue;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setFrameFlattening(FrameFlattening frameFlattening)
{
    if (m_values.frameFlattening == frameFlattening)
        return;
    m_values.frameFlattening = frameFlattening;
    setNeedsRelayoutAllFrames();
}
void Settings::setHiddenPageCSSAnimationSuspensionEnabled(bool hiddenPageCSSAnimationSuspensionEnabled)
{
    if (m_values.hiddenPageCSSAnimationSuspensionEnabled == hiddenPageCSSAnimationSuspensionEnabled)
        return;
    m_values.hiddenPageCSSAnimationSuspensionEnabled = hiddenPageCSSAnimationSuspensionEnabled;
    hiddenPageCSSAnimationSuspensionEnabledChanged();
}
void Settings::setHiddenPageDOMTimerThrottlingAutoIncreases(bool hiddenPageDOMTimerThrottlingAutoIncreases)
{
    if (m_values.hiddenPageDOMTimerThrottlingAutoIncreases == hiddenPageDOMTimerThrottlingAutoIncreases)
        return;
    m_values.hiddenPageDOMTimerThrottlingAutoIncreases = hiddenPageDOMTimerThrottlingAutoIncreases;
    hiddenPageDOMTimerThrottlingStateChanged();
}
void Settings::setHiddenPageDOMTimerThrottlingEnabled(bool hiddenPageDOMTimerThrottlingEnabled)
{
    if (m_values.hiddenPageDOMTimerThrottlingEnabled == hiddenPageDOMTimerThrottlingEnabled)
        return;
    m_values.hiddenPageDOMTimerThrottlingEnabled = hiddenPageDOMTimerThrottlingEnabled;
    hiddenPageDOMTimerThrottlingStateChanged();
}
void Settings::setICECandidateFilteringEnabled(bool iceCandidateFilteringEnabled)
{
    if (m_values.iceCandidateFilteringEnabled == iceCandidateFilteringEnabled)
        return;
    m_values.iceCandidateFilteringEnabled = iceCandidateFilteringEnabled;
    iceCandidateFilteringEnabledChanged();
}
void Settings::setImagesEnabled(bool imagesEnabled)
{
    if (m_values.imagesEnabled == imagesEnabled)
        return;
    m_values.imagesEnabled = imagesEnabled;
    imagesEnabledChanged();
}
void Settings::setLayoutViewportHeightExpansionFactor(double layoutViewportHeightExpansionFactor)
{
    if (m_values.layoutViewportHeightExpansionFactor == layoutViewportHeightExpansionFactor)
        return;
    m_values.layoutViewportHeightExpansionFactor = layoutViewportHeightExpansionFactor;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setLegacyLineLayoutVisualCoverageEnabled(bool legacyLineLayoutVisualCoverageEnabled)
{
    if (m_values.legacyLineLayoutVisualCoverageEnabled == legacyLineLayoutVisualCoverageEnabled)
        return;
    m_values.legacyLineLayoutVisualCoverageEnabled = legacyLineLayoutVisualCoverageEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setLoadsImagesAutomatically(bool loadsImagesAutomatically)
{
    if (m_values.loadsImagesAutomatically == loadsImagesAutomatically)
        return;
    m_values.loadsImagesAutomatically = loadsImagesAutomatically;
    imagesEnabledChanged();
}
void Settings::setMediaTypeOverride(const String& mediaTypeOverride)
{
    if (m_values.mediaTypeOverride == mediaTypeOverride)
        return;
    m_values.mediaTypeOverride = mediaTypeOverride;
    mediaTypeOverrideChanged();
}
void Settings::setMinimumFontSize(double minimumFontSize)
{
    if (m_values.minimumFontSize == minimumFontSize)
        return;
    m_values.minimumFontSize = minimumFontSize;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setMinimumLogicalFontSize(double minimumLogicalFontSize)
{
    if (m_values.minimumLogicalFontSize == minimumLogicalFontSize)
        return;
    m_values.minimumLogicalFontSize = minimumLogicalFontSize;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setPluginsEnabled(bool pluginsEnabled)
{
    if (m_values.pluginsEnabled == pluginsEnabled)
        return;
    m_values.pluginsEnabled = pluginsEnabled;
    pluginsEnabledChanged();
}
void Settings::setPunchOutWhiteBackgroundsInDarkMode(bool punchOutWhiteBackgroundsInDarkMode)
{
    if (m_values.punchOutWhiteBackgroundsInDarkMode == punchOutWhiteBackgroundsInDarkMode)
        return;
    m_values.punchOutWhiteBackgroundsInDarkMode = punchOutWhiteBackgroundsInDarkMode;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setScrollingPerformanceTestingEnabled(bool scrollingPerformanceTestingEnabled)
{
    if (m_values.scrollingPerformanceTestingEnabled == scrollingPerformanceTestingEnabled)
        return;
    m_values.scrollingPerformanceTestingEnabled = scrollingPerformanceTestingEnabled;
    scrollingPerformanceTestingEnabledChanged();
}
void Settings::setShouldAllowUserInstalledFonts(bool shouldAllowUserInstalledFonts)
{
    if (m_values.shouldAllowUserInstalledFonts == shouldAllowUserInstalledFonts)
        return;
    m_values.shouldAllowUserInstalledFonts = shouldAllowUserInstalledFonts;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setShowDebugBorders(bool showDebugBorders)
{
    if (m_values.showDebugBorders == showDebugBorders)
        return;
    m_values.showDebugBorders = showDebugBorders;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setShowRepaintCounter(bool showRepaintCounter)
{
    if (m_values.showRepaintCounter == showRepaintCounter)
        return;
    m_values.showRepaintCounter = showRepaintCounter;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setSimpleLineLayoutEnabled(bool simpleLineLayoutEnabled)
{
    if (m_values.simpleLineLayoutEnabled == simpleLineLayoutEnabled)
        return;
    m_values.simpleLineLayoutEnabled = simpleLineLayoutEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setStorageBlockingPolicy(StorageBlockingPolicy storageBlockingPolicy)
{
    if (m_values.storageBlockingPolicy == storageBlockingPolicy)
        return;
    m_values.storageBlockingPolicy = storageBlockingPolicy;
    storageBlockingPolicyChanged();
}
void Settings::setSubpixelAntialiasedLayerTextEnabled(bool subpixelAntialiasedLayerTextEnabled)
{
    if (m_values.subpixelAntialiasedLayerTextEnabled == subpixelAntialiasedLayerTextEnabled)
        return;
    m_values.subpixelAntialiasedLayerTextEnabled = subpixelAntialiasedLayerTextEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setTextAreasAreResizable(bool textAreasAreResizable)
{
    if (m_values.textAreasAreResizable == textAreasAreResizable)
        return;
    m_values.textAreasAreResizable = textAreasAreResizable;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setUserStyleSheetLocation(const URL& userStyleSheetLocation)
{
    if (m_values.userStyleSheetLocation == userStyleSheetLocation)
        return;
    m_values.userStyleSheetLocation = userStyleSheetLocation;
    userStyleSheetLocationChanged();
}
void Settings::setUsesBackForwardCache(bool usesBackForwardCache)
{
    if (m_values.usesBackForwardCache == usesBackForwardCache)
        return;
    m_values.usesBackForwardCache = usesBackForwardCache;
    usesBackForwardCacheChanged();
}
void Settings::setVisualViewportEnabled(bool visualViewportEnabled)
{
    if (m_values.visualViewportEnabled == visualViewportEnabled)
        return;
    m_values.visualViewportEnabled = visualViewportEnabled;
    setNeedsRecalcStyleInAllFrames();
}
#if ENABLE(LAYER_BASED_SVG_ENGINE)

void Settings::setLayerBasedSVGEngineEnabled(bool layerBasedSVGEngineEnabled)
{
    if (m_values.layerBasedSVGEngineEnabled == layerBasedSVGEngineEnabled)
        return;
    m_values.layerBasedSVGEngineEnabled = layerBasedSVGEngineEnabled;
    layerBasedSVGEngineEnabledChanged();
}
#endif
#if ENABLE(MEDIA_STREAM)
bool Settings::mediaCaptureRequiresSecureConnection() const
{
    if (UNLIKELY(m_values.mediaCaptureRequiresSecureConnectionInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.mediaCaptureRequiresSecureConnectionInspectorOverride.value();
    }
    return m_values.mediaCaptureRequiresSecureConnection;
}
bool Settings::mockCaptureDevicesEnabled() const
{
    if (UNLIKELY(m_values.mockCaptureDevicesEnabledInspectorOverride)) {
        ASSERT(InspectorInstrumentation::hasFrontends());
        return m_values.mockCaptureDevicesEnabledInspectorOverride.value();
    }
    return m_values.mockCaptureDevicesEnabled;
}

void Settings::setMockCaptureDevicesEnabled(bool mockCaptureDevicesEnabled)
{
    if (m_values.mockCaptureDevicesEnabled == mockCaptureDevicesEnabled)
        return;
    m_values.mockCaptureDevicesEnabled = mockCaptureDevicesEnabled;
    mockCaptureDevicesEnabledChanged();
}
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)

void Settings::setLegacyOverflowScrollingTouchEnabled(bool legacyOverflowScrollingTouchEnabled)
{
    if (m_values.legacyOverflowScrollingTouchEnabled == legacyOverflowScrollingTouchEnabled)
        return;
    m_values.legacyOverflowScrollingTouchEnabled = legacyOverflowScrollingTouchEnabled;
    setNeedsRelayoutAllFrames();
}
#endif
#if ENABLE(RESOURCE_USAGE)

void Settings::setResourceUsageOverlayVisible(bool resourceUsageOverlayVisible)
{
    if (m_values.resourceUsageOverlayVisible == resourceUsageOverlayVisible)
        return;
    m_values.resourceUsageOverlayVisible = resourceUsageOverlayVisible;
    resourceUsageOverlayVisibleChanged();
}
#endif
#if ENABLE(TEXT_AUTOSIZING)

void Settings::setShouldEnableTextAutosizingBoost(bool shouldEnableTextAutosizingBoost)
{
    if (m_values.shouldEnableTextAutosizingBoost == shouldEnableTextAutosizingBoost)
        return;
    m_values.shouldEnableTextAutosizingBoost = shouldEnableTextAutosizingBoost;
    shouldEnableTextAutosizingBoostChanged();
}
void Settings::setTextAutosizingEnabled(bool textAutosizingEnabled)
{
    if (m_values.textAutosizingEnabled == textAutosizingEnabled)
        return;
    m_values.textAutosizingEnabled = textAutosizingEnabled;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setTextAutosizingUsesIdempotentMode(bool textAutosizingUsesIdempotentMode)
{
    if (m_values.textAutosizingUsesIdempotentMode == textAutosizingUsesIdempotentMode)
        return;
    m_values.textAutosizingUsesIdempotentMode = textAutosizingUsesIdempotentMode;
    textAutosizingUsesIdempotentModeChanged();
}
void Settings::setTextAutosizingWindowSizeOverrideHeight(uint32_t textAutosizingWindowSizeOverrideHeight)
{
    if (m_values.textAutosizingWindowSizeOverrideHeight == textAutosizingWindowSizeOverrideHeight)
        return;
    m_values.textAutosizingWindowSizeOverrideHeight = textAutosizingWindowSizeOverrideHeight;
    setNeedsRecalcStyleInAllFrames();
}
void Settings::setTextAutosizingWindowSizeOverrideWidth(uint32_t textAutosizingWindowSizeOverrideWidth)
{
    if (m_values.textAutosizingWindowSizeOverrideWidth == textAutosizingWindowSizeOverrideWidth)
        return;
    m_values.textAutosizingWindowSizeOverrideWidth = textAutosizingWindowSizeOverrideWidth;
    setNeedsRecalcStyleInAllFrames();
}
#endif
#if USE(CORE_IMAGE)

void Settings::setAcceleratedFiltersEnabled(bool acceleratedFiltersEnabled)
{
    if (m_values.acceleratedFiltersEnabled == acceleratedFiltersEnabled)
        return;
    m_values.acceleratedFiltersEnabled = acceleratedFiltersEnabled;
    setNeedsRelayoutAllFrames();
}
#endif

void Settings::setAuthorAndUserStylesEnabledInspectorOverride(std::optional<bool> authorAndUserStylesEnabledInspectorOverride)
{
    if (m_values.authorAndUserStylesEnabledInspectorOverride == authorAndUserStylesEnabledInspectorOverride)
        return;
        m_values.authorAndUserStylesEnabledInspectorOverride = authorAndUserStylesEnabledInspectorOverride;
    setNeedsRecalcStyleInAllFrames();
}

void Settings::setICECandidateFilteringEnabledInspectorOverride(std::optional<bool> iceCandidateFilteringEnabledInspectorOverride)
{
    if (m_values.iceCandidateFilteringEnabledInspectorOverride == iceCandidateFilteringEnabledInspectorOverride)
        return;
        m_values.iceCandidateFilteringEnabledInspectorOverride = iceCandidateFilteringEnabledInspectorOverride;
    iceCandidateFilteringEnabledChanged();
}

void Settings::setImagesEnabledInspectorOverride(std::optional<bool> imagesEnabledInspectorOverride)
{
    if (m_values.imagesEnabledInspectorOverride == imagesEnabledInspectorOverride)
        return;
        m_values.imagesEnabledInspectorOverride = imagesEnabledInspectorOverride;
    imagesEnabledChanged();
}

void Settings::setMockCaptureDevicesEnabledInspectorOverride(std::optional<bool> mockCaptureDevicesEnabledInspectorOverride)
{
    if (m_values.mockCaptureDevicesEnabledInspectorOverride == mockCaptureDevicesEnabledInspectorOverride)
        return;
        m_values.mockCaptureDevicesEnabledInspectorOverride = mockCaptureDevicesEnabledInspectorOverride;
#if ENABLE(MEDIA_STREAM)
    mockCaptureDevicesEnabledChanged();
#endif
}

void Settings::setShowDebugBordersInspectorOverride(std::optional<bool> showDebugBordersInspectorOverride)
{
    if (m_values.showDebugBordersInspectorOverride == showDebugBordersInspectorOverride)
        return;
        m_values.showDebugBordersInspectorOverride = showDebugBordersInspectorOverride;
    setNeedsRecalcStyleInAllFrames();
}

void Settings::setShowRepaintCounterInspectorOverride(std::optional<bool> showRepaintCounterInspectorOverride)
{
    if (m_values.showRepaintCounterInspectorOverride == showRepaintCounterInspectorOverride)
        return;
        m_values.showRepaintCounterInspectorOverride = showRepaintCounterInspectorOverride;
    setNeedsRecalcStyleInAllFrames();
}

}
