/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCSSStyleDeclaration.h"

#include "ActiveDOMObject.h"
#include "CustomElementReactionQueue.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "IDLTypes.h"
#include "JSCSSRule.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBase.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSDeprecatedCSSOMValue.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/ArrayPrototype.h>
#include <JavaScriptCore/BuiltinNames.h>
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/PropertyNameArray.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_item);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_setProperty);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_removeProperty);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclarationConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssText);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssText);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_length);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_parentRule);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssFloat);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssFloat);

class JSCSSStyleDeclarationPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCSSStyleDeclarationPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCSSStyleDeclarationPrototype* ptr = new (NotNull, JSC::allocateCell<JSCSSStyleDeclarationPrototype>(vm)) JSCSSStyleDeclarationPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCSSStyleDeclarationPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCSSStyleDeclarationPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCSSStyleDeclarationPrototype, JSCSSStyleDeclarationPrototype::Base);

using JSCSSStyleDeclarationDOMConstructor = JSDOMConstructorNotConstructable<JSCSSStyleDeclaration>;

template<> const ClassInfo JSCSSStyleDeclarationDOMConstructor::s_info = { "CSSStyleDeclaration", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclarationDOMConstructor) };

template<> JSValue JSCSSStyleDeclarationDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCSSStyleDeclarationDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "CSSStyleDeclaration"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSCSSStyleDeclaration::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSCSSStyleDeclarationPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclarationConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cssText", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_cssText), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_cssText) } },
    { "length", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_length), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "parentRule", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_parentRule), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cssFloat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_cssFloat), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_cssFloat) } },
    { "AppleColorFilter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubCaptionSide", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubHyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextCombine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasisColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasisStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextTransform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubWordBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubWritingMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignSelf", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlt", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationFillMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationIterationCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationName", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationPlayState", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAppearance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackdropFilter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackfaceVisibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBottomLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBottomRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderHorizontalSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderTopLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderTopRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderVerticalSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxDecorationBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxFlex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxFlexGroup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxLines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxOrdinalGroup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxOrient", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxPack", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxReflect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxShadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxSizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitClipPath", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnAxis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakInside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnFill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnProgression", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnSpan", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitCursorVisibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFilter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexBasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexFlow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexGrow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexShrink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexWrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFontKerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFontSmoothing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateCharacter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitLines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitInitialLetter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitJustifyContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitJustifyItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineBoxContain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineClamp", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineGrid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineSnap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLocale", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMask", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageOutset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageSlice", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageSource", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskComposite", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPositionX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPositionY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskSourceType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaxLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaxLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMinLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMinLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitNbspMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitOrder", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspective", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPrintColorAdjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitRtlOrdering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitRubyPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeImageThreshold", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeMargin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeOutside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTapHighlightColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextCombine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecoration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationLine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationSkip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationsInEffect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextFillColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextSecurity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStroke", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStrokeColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStrokeWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextUnderlinePosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextZoom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginZ", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionProperty", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserDrag", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserModify", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserSelect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitWritingMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "accentColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "additiveSymbols", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignSelf", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignmentBaseline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "all", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alt", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationComposition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationFillMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationIterationCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationName", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationPlayState", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "appearance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "aspectRatio", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backfaceVisibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "background", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundAttachment", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundBlendMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPositionX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPositionY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "basePalette", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "baselineShift", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "blockSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "border", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderCollapse", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderEndEndRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderEndStartRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageOutset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageSlice", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageSource", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStartEndRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStartStartRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "boxShadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "boxSizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakInside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "bufferedRendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "captionSide", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "caretColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clear", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clipPath", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clipRule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorAdjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorInterpolation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorInterpolationFilters", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorScheme", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnFill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnSpan", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "contain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "container", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containerName", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containerType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "counterIncrement", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "counterReset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cursor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cx", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cy", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "display", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "dominantBaseline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "emptyCells", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fallback", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fillOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fillRule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "filter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexBasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexFlow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexGrow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexShrink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexWrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "float", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "floodColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "floodOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "font", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontDisplay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontFamily", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontFeatureSettings", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontKerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontOpticalSizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontPalette", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontStretch", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontSynthesis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariant", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantAlternates", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantCaps", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantEastAsian", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantLigatures", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantNumeric", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariationSettings", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontWeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "glyphOrientationHorizontal", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "glyphOrientationVertical", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "grid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridArea", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoColumns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoFlow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoRows", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumn", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateAreas", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateColumns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateRows", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "hangingPunctuation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "imageOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "imageRendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inlineSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inputSecurity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "isolation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifyContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifyItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifySelf", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "kerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "letterSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lightingColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lineBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lineHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyleImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStylePosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyleType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "margin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marker", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerMid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mask", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskComposite", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mathStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxBlockSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxInlineSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minBlockSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minInlineSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mixBlendMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "negative", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "objectFit", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "objectPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetAnchor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetDistance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetPath", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetRotate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "order", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "orphans", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineOffset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowWrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overrideColors", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehavior", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pad", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "padding", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "page", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakInside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paintOrder", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspective", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeSelf", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pointerEvents", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "prefix", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "printColorAdjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "quotes", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "r", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "range", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "resize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rotate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rowGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rx", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "ry", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scale", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollBehavior", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMargin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPadding", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlock", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlockEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlockStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInlineEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInlineStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMargin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginBottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginLeft", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginRight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginTop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapStop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeImageThreshold", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeMargin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeOutside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeRendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "speakAs", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "src", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stopColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stopOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stroke", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeDasharray", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeDashoffset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeLinecap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeLinejoin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeMiterlimit", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "suffix", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "supportedColorSchemes", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "symbols", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "system", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "tabSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "tableLayout", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textAnchor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textCombineUpright", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecoration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationLine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationSkip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationSkipInk", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationThickness", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textIndent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textOverflow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textRendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textShadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textTransform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textUnderlineOffset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textUnderlinePosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "touchAction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformBox", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginZ", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionProperty", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "translate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "unicodeBidi", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "unicodeRange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "vectorEffect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "verticalAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "visibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "whiteSpace", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "widows", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "willChange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordWrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "writingMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "zIndex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "zoom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "webkitAlignContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlignItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlignSelf", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlt", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationFillMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationIterationCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationName", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationPlayState", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAppearance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackdropFilter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackfaceVisibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBottomLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBottomRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderHorizontalSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderTopLeftRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderTopRightRadius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderVerticalSpacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxDecorationBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxFlex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxFlexGroup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxLines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxOrdinalGroup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxOrient", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxPack", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxReflect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxShadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxSizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitClipPath", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnAxis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakInside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnCount", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnFill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnGap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnProgression", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnSpan", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitCursorVisibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFilter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexBasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexDirection", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexFlow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexGrow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexShrink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexWrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFontKerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFontSmoothing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateCharacter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitLines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitInitialLetter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitJustifyContent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitJustifyItems", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineAlign", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineBoxContain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineClamp", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineGrid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineSnap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLocale", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMask", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageOutset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageSlice", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageSource", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskClip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskComposite", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskImage", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPositionX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPositionY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskRepeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskSize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskSourceType", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaxLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaxLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMinLogicalHeight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMinLogicalWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitNbspMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitOpacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitOrder", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingAfter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingBefore", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspective", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPrintColorAdjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitRtlOrdering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitRubyPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeImageThreshold", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeMargin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeOutside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTapHighlightColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextCombine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecoration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationLine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationSkip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationsInEffect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisPosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextFillColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextSecurity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStroke", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStrokeColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStrokeWidth", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextUnderlinePosition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextZoom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOrigin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginX", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginY", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginZ", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionDelay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionDuration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionProperty", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionTimingFunction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserDrag", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserModify", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserSelect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitWritingMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "-apple-color-filter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-caption-side", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-hyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-combine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-orientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-transform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-word-break", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-writing-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-items", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-self", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-alt", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-delay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-duration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-fill-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-iteration-count", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-name", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-play-state", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-timing-function", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-appearance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-backdrop-filter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-backface-visibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-clip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-bottom-left-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-bottom-right-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-horizontal-spacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-top-left-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-top-right-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-vertical-spacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-align", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-decoration-break", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-flex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-flex-group", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-lines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-ordinal-group", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-orient", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-pack", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-reflect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-shadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-sizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-clip-path", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-axis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-inside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-count", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-fill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-progression", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-span", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-columns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-cursor-visibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-filter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-basis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-flow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-grow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-shrink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-wrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-font-kerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-font-smoothing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-character", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-lines", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-initial-letter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-justify-content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-justify-items", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-align", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-box-contain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-break", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-clamp", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-grid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-snap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-locale", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-logical-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-logical-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-outset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-repeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-slice", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-source", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-clip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-composite", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-repeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-source-type", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-max-logical-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-max-logical-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-min-logical-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-min-logical-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-nbsp-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-order", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-print-color-adjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-rtl-ordering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-ruby-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-image-threshold", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-margin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-outside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-tap-highlight-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-combine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-line", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-skip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decorations-in-effect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-fill-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-orientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-security", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-underline-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-zoom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-z", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-delay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-duration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-property", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-timing-function", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-drag", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-modify", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-select", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-writing-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "accent-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "additive-symbols", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-items", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-self", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "alignment-baseline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-composition", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-delay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-duration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-fill-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-iteration-count", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-name", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-play-state", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-timing-function", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "aspect-ratio", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "backface-visibility", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-attachment", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-blend-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-clip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-repeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "base-palette", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "baseline-shift", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "block-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-left-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-right-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-collapse", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-end-end-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-end-start-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-outset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-repeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-slice", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-source", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-spacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-start-end-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-start-start-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-left-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-right-radius", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "box-shadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "box-sizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-inside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "buffered-rendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "caption-side", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "caret-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "clip-path", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "clip-rule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-adjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-interpolation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-interpolation-filters", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-scheme", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-count", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-fill", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-span", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "container-name", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "container-type", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "counter-increment", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "counter-reset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "dominant-baseline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "empty-cells", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "fill-opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "fill-rule", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-basis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-direction", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-flow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-grow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-shrink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-wrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flood-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flood-opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-display", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-family", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-feature-settings", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-kerning", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-optical-sizing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-palette", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-stretch", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-synthesis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-alternates", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-caps", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-east-asian", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-ligatures", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-numeric", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variation-settings", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-weight", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "glyph-orientation-horizontal", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "glyph-orientation-vertical", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-area", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-columns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-flow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-rows", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-areas", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-columns", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-rows", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "hanging-punctuation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "image-orientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "image-rendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inline-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "input-security", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-items", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-self", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "letter-spacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "lighting-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "line-break", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "line-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-type", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-mid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-clip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-composite", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-image", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-repeat", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-type", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "math-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-block-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-inline-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-block-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-inline-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mix-blend-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "object-fit", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "object-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-anchor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-distance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-path", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-rotate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-offset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-wrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "override-colors", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-after", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-before", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-inside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "paint-order", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-content", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-items", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-self", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "pointer-events", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "print-color-adjust", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "row-gap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-behavior", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline-end", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline-start", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-align", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-bottom", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-left", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-right", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-top", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-stop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-type", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-image-threshold", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-margin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-outside", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-rendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "speak-as", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stop-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stop-opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-dasharray", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-dashoffset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-linecap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-linejoin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-miterlimit", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-opacity", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "supported-color-schemes", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "tab-size", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "table-layout", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-align", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-anchor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-combine-upright", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-line", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-skip", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-skip-ink", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-thickness", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-color", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-indent", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-orientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-overflow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-rendering", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-shadow", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-transform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-underline-offset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-underline-position", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "touch-action", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-box", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-x", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-y", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-z", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-delay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-duration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-property", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-timing-function", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "unicode-bidi", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "unicode-range", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "vector-effect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "vertical-align", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "white-space", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "will-change", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-break", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-spacing", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-wrap", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "writing-mode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "z-index", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "epubCaptionSide", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubHyphens", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextCombine", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasis", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasisColor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasisStyle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextOrientation", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextTransform", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubWordBreak", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubWritingMode", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "item", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_item), (intptr_t) (1) } },
    { "getPropertyValue", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue), (intptr_t) (1) } },
    { "getPropertyPriority", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority), (intptr_t) (1) } },
    { "setProperty", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_setProperty), (intptr_t) (2) } },
    { "removeProperty", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_removeProperty), (intptr_t) (1) } },
    { "getPropertyShorthand", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand), (intptr_t) (0) } },
    { "isPropertyImplicit", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit), (intptr_t) (0) } },
    { "getPropertyCSSValue", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue), (intptr_t) (1) } },
};

const ClassInfo JSCSSStyleDeclarationPrototype::s_info = { "CSSStyleDeclaration", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclarationPrototype) };

void JSCSSStyleDeclarationPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCSSStyleDeclaration::info(), JSCSSStyleDeclarationPrototypeTableValues, *this);
    bool hasDisabledRuntimeProperties = false;
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().accentColorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("accentColor"), strlen("accentColor"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("additiveSymbols"), strlen("additiveSymbols"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().webAnimationsCompositeOperationsEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("animationComposition"), strlen("animationComposition"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().aspectRatioEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("aspectRatio"), strlen("aspectRatio"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainmentEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("contain"), strlen("contain"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("containerName"), strlen("containerName"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("containerType"), strlen("containerType"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("fallback"), strlen("fallback"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssInputSecurityEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("inputSecurity"), strlen("inputSecurity"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("negative"), strlen("negative"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offsetAnchor"), strlen("offsetAnchor"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offsetDistance"), strlen("offsetDistance"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offsetPath"), strlen("offsetPath"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offsetPosition"), strlen("offsetPosition"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offsetRotate"), strlen("offsetRotate"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscrollBehavior"), strlen("overscrollBehavior"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscrollBehaviorX"), strlen("overscrollBehaviorX"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscrollBehaviorY"), strlen("overscrollBehaviorY"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("pad"), strlen("pad"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("prefix"), strlen("prefix"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("range"), strlen("range"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("rotate"), strlen("rotate"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("scale"), strlen("scale"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().CSSOMViewSmoothScrollingEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("scrollBehavior"), strlen("scrollBehavior"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("suffix"), strlen("suffix"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("symbols"), strlen("symbols"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("system"), strlen("system"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("translate"), strlen("translate"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().accentColorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("accent-color"), strlen("accent-color"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("additive-symbols"), strlen("additive-symbols"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().webAnimationsCompositeOperationsEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("animation-composition"), strlen("animation-composition"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().aspectRatioEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("aspect-ratio"), strlen("aspect-ratio"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("container-name"), strlen("container-name"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("container-type"), strlen("container-type"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssInputSecurityEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("input-security"), strlen("input-security"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offset-anchor"), strlen("offset-anchor"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offset-distance"), strlen("offset-distance"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offset-path"), strlen("offset-path"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offset-position"), strlen("offset-position"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("offset-rotate"), strlen("offset-rotate"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscroll-behavior"), strlen("overscroll-behavior"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscroll-behavior-x"), strlen("overscroll-behavior-x"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("overscroll-behavior-y"), strlen("overscroll-behavior-y"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().CSSOMViewSmoothScrollingEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("scroll-behavior"), strlen("scroll-behavior"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (hasDisabledRuntimeProperties && structure()->isDictionary())
        flattenDictionaryObject(vm);
    putDirect(vm, vm.propertyNames->iteratorSymbol, globalObject()->arrayPrototype()->getDirect(vm, vm.propertyNames->builtinNames().valuesPrivateName()), static_cast<unsigned>(JSC::PropertyAttribute::DontEnum));
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSCSSStyleDeclaration::s_info = { "CSSStyleDeclaration", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclaration) };

JSCSSStyleDeclaration::JSCSSStyleDeclaration(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CSSStyleDeclaration>&& impl)
    : JSDOMWrapper<CSSStyleDeclaration>(structure, globalObject, WTFMove(impl))
{
}

void JSCSSStyleDeclaration::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, CSSStyleDeclaration>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSCSSStyleDeclaration::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCSSStyleDeclarationPrototype::create(vm, &globalObject, JSCSSStyleDeclarationPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCSSStyleDeclaration::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCSSStyleDeclaration>(vm, globalObject);
}

JSValue JSCSSStyleDeclaration::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCSSStyleDeclarationDOMConstructor, DOMConstructorID::CSSStyleDeclaration>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCSSStyleDeclaration::destroy(JSC::JSCell* cell)
{
    JSCSSStyleDeclaration* thisObject = static_cast<JSCSSStyleDeclaration*>(cell);
    thisObject->JSCSSStyleDeclaration::~JSCSSStyleDeclaration();
}

bool JSCSSStyleDeclaration::getOwnPropertySlot(JSObject* object, JSGlobalObject* lexicalGlobalObject, PropertyName propertyName, PropertySlot& slot)
{
    auto throwScope = DECLARE_THROW_SCOPE(JSC::getVM(lexicalGlobalObject));
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (auto index = parseIndex(propertyName)) {
        if (index.value() < thisObject->wrapped().length()) {
            auto value = toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, thisObject->wrapped().item(index.value()));
            RETURN_IF_EXCEPTION(throwScope, false);
            slot.setValue(thisObject, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly), value);
            return true;
        }
    }
    return JSObject::getOwnPropertySlot(object, lexicalGlobalObject, propertyName, slot);
}

bool JSCSSStyleDeclaration::getOwnPropertySlotByIndex(JSObject* object, JSGlobalObject* lexicalGlobalObject, unsigned index, PropertySlot& slot)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (LIKELY(index <= MAX_ARRAY_INDEX)) {
        if (index < thisObject->wrapped().length()) {
            auto value = toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, thisObject->wrapped().item(index));
            RETURN_IF_EXCEPTION(throwScope, false);
            slot.setValue(thisObject, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly), value);
            return true;
        }
    }
    return JSObject::getOwnPropertySlotByIndex(object, lexicalGlobalObject, index, slot);
}

void JSCSSStyleDeclaration::getOwnPropertyNames(JSObject* object, JSGlobalObject* lexicalGlobalObject, PropertyNameArray& propertyNames, DontEnumPropertiesMode mode)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(object, info());
    for (unsigned i = 0, count = thisObject->wrapped().length(); i < count; ++i)
        propertyNames.add(Identifier::from(vm, i));
    JSObject::getOwnPropertyNames(object, lexicalGlobalObject, propertyNames, mode);
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclarationConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSCSSStyleDeclarationPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSCSSStyleDeclaration::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForCamelCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForCamelCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForWebKitCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForWebKitCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForDashedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForDashedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForDashedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForDashedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForDashedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForDashedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForEpubCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForEpubCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_cssTextGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUSVString>(lexicalGlobalObject, throwScope, impl.cssText())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssText, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_cssTextGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_cssTextSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUSVString>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setCssText(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssText, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::set<setJSCSSStyleDeclaration_cssTextSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_lengthGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.length())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_length, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_lengthGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_parentRuleGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLNullable<IDLInterface<CSSRule>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.parentRule())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_parentRule, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_parentRuleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_cssFloatGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.cssFloat())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssFloat, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_cssFloatGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_cssFloatSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setCssFloat(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssFloat, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::set<setJSCSSStyleDeclaration_cssFloatSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_itemBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto index = convert<IDLUnsignedLong>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.item(WTFMove(index)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_item, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_itemBody>(*lexicalGlobalObject, *callFrame, "item");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyValueBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.getPropertyValue(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyValueBody>(*lexicalGlobalObject, *callFrame, "getPropertyValue");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyPriorityBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.getPropertyPriority(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyPriorityBody>(*lexicalGlobalObject, *callFrame, "getPropertyPriority");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_setPropertyBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto value = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->argument(2);
    auto priority = argument2.value().isUndefined() ? emptyString() : convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUndefined>(*lexicalGlobalObject, throwScope, [&]() -> decltype(auto) { return impl.setProperty(WTFMove(property), WTFMove(value), WTFMove(priority)); })));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_setProperty, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_setPropertyBody>(*lexicalGlobalObject, *callFrame, "setProperty");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_removePropertyBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.removeProperty(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_removeProperty, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_removePropertyBody>(*lexicalGlobalObject, *callFrame, "removeProperty");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthandBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto propertyName = argument0.value().isUndefined() ? String() : convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLNullable<IDLDOMString>>(*lexicalGlobalObject, throwScope, impl.getPropertyShorthand(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthandBody>(*lexicalGlobalObject, *callFrame, "getPropertyShorthand");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicitBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto propertyName = argument0.value().isUndefined() ? String() : convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLBoolean>(*lexicalGlobalObject, throwScope, impl.isPropertyImplicit(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicitBody>(*lexicalGlobalObject, *callFrame, "isPropertyImplicit");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValueBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto propertyName = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLNullable<IDLInterface<DeprecatedCSSOMValue>>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, impl.getPropertyCSSValue(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValueBody>(*lexicalGlobalObject, *callFrame, "getPropertyCSSValue");
}

JSC::GCClient::IsoSubspace* JSCSSStyleDeclaration::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSCSSStyleDeclaration, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForCSSStyleDeclaration.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForCSSStyleDeclaration = WTFMove(space); },
        [] (auto& spaces) { return spaces.m_subspaceForCSSStyleDeclaration.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForCSSStyleDeclaration = WTFMove(space); }
    );
}

template<typename Visitor>
void JSCSSStyleDeclaration::visitChildrenImpl(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

DEFINE_VISIT_CHILDREN(JSCSSStyleDeclaration);

template<typename Visitor>
void JSCSSStyleDeclaration::visitOutputConstraints(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitOutputConstraints(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

template void JSCSSStyleDeclaration::visitOutputConstraints(JSCell*, AbstractSlotVisitor&);
template void JSCSSStyleDeclaration::visitOutputConstraints(JSCell*, SlotVisitor&);
void JSCSSStyleDeclaration::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSCSSStyleDeclarationOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsCSSStyleDeclaration = jsCast<JSCSSStyleDeclaration*>(handle.slot()->asCell());
    void* root = WebCore::root(&jsCSSStyleDeclaration->wrapped());
    if (UNLIKELY(reason))
        *reason = "Reachable from jsCSSStyleDeclaration";
    return visitor.containsOpaqueRoot(root);
}

void JSCSSStyleDeclarationOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCSSStyleDeclaration = static_cast<JSCSSStyleDeclaration*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCSSStyleDeclaration->wrapped(), jsCSSStyleDeclaration);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<CSSStyleDeclaration>&& impl)
{
    return createWrapper<CSSStyleDeclaration>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, CSSStyleDeclaration& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

CSSStyleDeclaration* JSCSSStyleDeclaration::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSCSSStyleDeclaration*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
